VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cButtonBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Clase:       cButtonBar
'Autor:       Esteban Gonzalez
'Fecha:       05 de diciembre de 2007
'Modificado:  03 de diciembre de 2009
'Descripcion: Clase que emula una barra de botones
'             horizontales.
'             Permite el uso de skins para los botones.

Option Explicit

Private Declare Sub Sleep Lib "kernel32.dll" (ByVal dwMilliseconds As Long)
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal Bytelen As Long)
Private Declare Sub FillMemory Lib "kernel32.dll" Alias "RtlFillMemory" (ByRef Destination As Any, ByVal Length As Long, ByVal Fill As Byte)
Private Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer
Private Const VK_TAB = &H9
Private Const VK_RETURN As Long = &HD
Private Const VK_SPACE As Long = &H20

'Funciones para averiguar si el mouse esta sobre el picturebox.
Private Declare Function GetFocusAPI Lib "user32.dll" Alias "GetFocus" () As Long
Private Declare Function SetCapture Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long


Private Declare Function GetStockObject Lib "gdi32.dll" (ByVal nIndex As Long) As Long
Private Const BLACK_BRUSH As Long = 4
Private Const DKGRAY_BRUSH As Long = 3
Private Const WHITE_BRUSH As Long = 0
Private Declare Function GetSysColor Lib "user32.dll" (ByVal nIndex As Long) As Long
Private Declare Function GetSysColorBrush Lib "user32.dll" (ByVal nIndex As Long) As Long
Private Const COLOR_BTNFACE As Long = 15
Private Const COLOR_3DFACE As Long = COLOR_BTNFACE
Private Const COLOR_BTNHIGHLIGHT As Long = 20
Private Const COLOR_3DHILIGHT As Long = COLOR_BTNHIGHLIGHT
Private Const COLOR_3DHIGHLIGHT As Long = COLOR_BTNHIGHLIGHT
Private Const COLOR_BTNSHADOW As Long = 16
Private Const COLOR_3DSHADOW As Long = COLOR_BTNSHADOW

Private Declare Function GetCurrentObject Lib "gdi32.dll" (ByVal hDC As Long, ByVal uObjectType As Long) As Long
Private Const OBJ_BITMAP As Long = 7
Private Const OBJ_BRUSH As Long = 2
Private Const OBJ_FONT As Long = 6
Private Const OBJ_PEN As Long = 1

Private Declare Function SetRect Lib "user32.dll" (ByRef lpRect As RECT, ByVal x1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function OffsetRect Lib "user32.dll" (ByRef lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function PtInRect Lib "user32.dll" (ByRef lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long

Private Declare Function CreateCompatibleDC Lib "gdi32.dll" (ByVal hDC As Long) As Long
Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long
Private Declare Function DeleteDC Lib "gdi32.dll" (ByVal hDC As Long) As Long

Private Declare Function BeginPath Lib "gdi32.dll" (ByVal hDC As Long) As Long
Private Declare Function EndPath Lib "gdi32.dll" (ByVal hDC As Long) As Long
Private Declare Function SelectClipPath Lib "gdi32.dll" (ByVal hDC As Long, ByVal iMode As Long) As Long
Private Declare Function SelectClipRgn Lib "gdi32.dll" (ByVal hDC As Long, ByVal hRgn As Long) As Long
Private Const RGN_AND As Long = 1
Private Const RGN_COPY As Long = 5


'FUNCIONES SOBRE EL MODO Y OBJETOS DEL DC
Private Declare Function GetBkMode Lib "gdi32.dll" (ByVal hDC As Long) As Long
Private Declare Function SetBkMode Lib "gdi32.dll" (ByVal hDC As Long, ByVal nBkMode As Long) As Long
Private Declare Function SetBkColor Lib "gdi32.dll" (ByVal hDC As Long, ByVal crColor As Long) As Long
Private Declare Function SetTextColor Lib "gdi32.dll" (ByVal hDC As Long, ByVal crColor As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32.dll" (ByVal crColor As Long) As Long
Private Declare Function CreatePen Lib "gdi32.dll" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Declare Function GetBkColor Lib "gdi32.dll" (ByVal hDC As Long) As Long
Private Declare Function GetTextColor Lib "gdi32.dll" (ByVal hDC As Long) As Long

Private Const OPAQUE As Long = 2
Private Const TRANSPARENT As Long = 1
Private Const PS_SOLID As Long = 0
Private Const PS_DASH As Long = 1
Private Const PS_DOT As Long = 2


'FUNCIONES DE TEXTO
Private Declare Function DrawText Lib "user32.dll" Alias "DrawTextA" (ByVal hDC As Long, ByVal lpStr As String, ByVal nCount As Long, ByRef lpRect As RECT, ByVal wFormat As Long) As Long
Private Declare Function DrawTextEx Lib "user32.dll" Alias "DrawTextExA" (ByVal hDC As Long, ByVal lpsz As String, ByVal n As Long, ByRef lpRect As RECT, ByVal un As Long, ByRef lpDrawTextParams As Any) As Long

Private Const DT_LEFT As Long = &H0&
Private Const DT_RIGHT As Long = &H2&
Private Const DT_TOP As Long = &H0&
Private Const DT_VCENTER As Long = &H4&
Private Const DT_CENTER As Long = &H1&
Private Const DT_BOTTOM As Long = &H8&
Private Const DT_CALCRECT As Long = &H400&
Private Const DT_EXPANDTABS As Long = &H40&
Private Const DT_SINGLELINE As Long = &H20&
Private Const DT_MULTILINE As Long = (&H1&)
Private Const DT_END_ELLIPSIS As Long = &H8000&
Private Const DT_NOPREFIX As Long = &H800&
Private Const DT_WORD_ELLIPSIS As Long = &H40000

'FUNCIONES PARA DIBUJAR LOS BOTONES COMUNES
Private Declare Function DrawFocusRectAPI Lib "user32.dll" Alias "DrawFocusRect" (ByVal hDC As Long, ByRef lpRect As RECT) As Long
Private Declare Function DrawFrameControl Lib "user32.dll" (ByVal hDC As Long, ByRef lpRect As RECT, ByVal un1 As Long, ByVal un2 As Long) As Long
Private Const DFC_BUTTON As Long = 4
Private Const DFCS_BUTTONPUSH As Long = &H10
Private Const DFCS_FLAT As Long = &H4000
Private Const DFCS_HOT As Long = &H1000
Private Const DFCS_INACTIVE As Long = &H100
Private Const DFCS_PUSHED As Long = &H200
Private Const DFCS_CHECKED As Long = &H400
Private Const DFCS_ADJUSTRECT As Long = &H2000

Private Declare Function DrawEdge Lib "user32.dll" (ByVal hDC As Long, ByRef qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Long
Private Const BDR_INNER As Long = &HC
Private Const BDR_OUTER As Long = &H3
Private Const BDR_RAISED As Long = &H5
Private Const BDR_RAISEDINNER As Long = &H4
Private Const BDR_RAISEDOUTER As Long = &H1
Private Const BDR_SUNKEN As Long = &HA
Private Const BDR_SUNKENINNER As Long = &H8
Private Const BDR_SUNKENOUTER As Long = &H2
Private Const EDGE_BUMP As Long = (BDR_RAISEDOUTER Or BDR_SUNKENINNER)
Private Const EDGE_ETCHED As Long = (BDR_SUNKENOUTER Or BDR_RAISEDINNER)
Private Const EDGE_RAISED As Long = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
Private Const EDGE_SUNKEN As Long = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)
Private Const EDGE_FLAT As Long = BDR_RAISEDINNER
Private Const EDGE_FLAT_DOWN As Long = BDR_SUNKENOUTER
Private Const BF_ADJUST As Long = &H2000
Private Const BF_BOTTOM As Long = &H8
Private Const BF_FLAT As Long = &H4000
Private Const BF_LEFT As Long = &H1
Private Const BF_RIGHT As Long = &H4
Private Const BF_TOP As Long = &H2
Private Const BF_SOFT As Long = &H1000
Private Const BF_RECT As Long = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)


'FUNCIONES DEL BITMAP
Private Declare Function CreateCompatibleBitmap Lib "gdi32.dll" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function CreateBitmap Lib "gdi32.dll" (ByVal nWidth As Long, ByVal nHeight As Long, ByVal nPlanes As Long, ByVal nBitCount As Long, ByRef lpBits As Any) As Long
'Nota: Cambiar el valor Byval de LpVoid as ByRef en CreateDibSection
Private Declare Function CreateDIBSection Lib "gdi32.dll" (ByVal hDC As Long, ByRef pBitmapInfo As BITMAPINFO, ByVal un As Long, ByRef lplpVoid As Long, ByVal handle As Long, ByVal dw As Long) As Long
Private Declare Function DrawState Lib "user32.dll" Alias "DrawStateA" (ByVal hDC As Long, ByVal HBrush As Long, ByVal lpDrawStateProc As Long, ByVal lParam As Long, ByVal wParam As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal n3 As Long, ByVal n4 As Long, ByVal un As Long) As Long
Private Declare Function CreateDIBPatternBrushPt Lib "gdi32.dll" (ByRef lpPackedDIB As Any, ByVal iUsage As Long) As Long
Private Declare Function GetObjectAPI Lib "gdi32.dll" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, ByRef lpObject As Any) As Long

Private Const DST_BITMAP As Long = &H4
Private Const DST_ICON As Long = &H3
Private Const DST_TEXT As Long = &H1
Private Const DSS_DISABLED As Long = &H20
Private Const DSS_NORMAL As Long = &H0
Private Const DSS_MONO As Long = &H80


Private Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type

Private Const BI_RGB As Long = 0&
Private Const DIB_RGB_COLORS As Long = 0

Private Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type

Private Type RGBStruct
 Red As Byte
 Green As Byte
 Blue As Byte
 AlphaChannel As Byte
End Type

Private Type BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Private Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors(4) As Long
End Type

'FUNCIONES PARA DIBUJAR SOBRE EL DC O BITMAP
Private Declare Function StretchBlt Lib "gdi32.dll" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Private Declare Function StretchDIBits Lib "gdi32.dll" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal dx As Long, ByVal dy As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal wSrcWidth As Long, ByVal wSrcHeight As Long, ByRef lpBits As Any, ByRef lpBitsInfo As BITMAPINFO, ByVal wUsage As Long, ByVal dwRop As Long) As Long
Private Declare Function BitBlt Lib "gdi32.dll" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function FrameRect Lib "user32.dll" (ByVal hDC As Long, ByRef lpRect As RECT, ByVal HBrush As Long) As Long
Private Declare Function FillRect Lib "user32.dll" (ByVal hDC As Long, ByRef lpRect As RECT, ByVal HBrush As Long) As Long
Private Declare Function Rectangle Lib "gdi32.dll" (ByVal hDC As Long, ByVal x1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function Ellipse Lib "gdi32.dll" (ByVal hDC As Long, ByVal x1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function Polygon Lib "gdi32.dll" (ByVal hDC As Long, ByVal lpPoint As Long, ByVal nCount As Long) As Long
Private Declare Function Polyline Lib "gdi32.dll" (ByVal hDC As Long, ByRef lpPoint As POINTAPI, ByVal nCount As Long) As Long
Private Declare Function APIGetPixel Lib "gdi32.dll" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function SetPixel Lib "gdi32.dll" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long

Private Declare Function ExtFloodFill Lib "gdi32.dll" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long, ByVal wFillType As Long) As Long
Private Const FLOODFILLBORDER As Long = 0
Private Const FLOODFILLSURFACE As Long = 1

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type POINTAPI
 X As Long
 Y As Long
End Type

Private Type SafeArrayBound
    cElements As Long
    lLbound As Long
End Type

Private Type SAFEARRAY1D
    cDims As Integer
    fFeatures As Integer
    cbElements As Long
    cLocks As Long
    pvData As Long
    Bounds(0 To 0) As SafeArrayBound
End Type

Private Type SAFEARRAY2D
    cDims As Integer
    fFeatures As Integer
    cbElements As Long
    cLocks As Long
    pvData As Long
    Bounds(0 To 1) As SafeArrayBound
End Type

'FUNCIONES PARA TRABAJAR CON CODIGO ASSEMBLER
'Nota: Para compilar este Programa en VB6, cambiar las
'referencias Lib "msvbvm50.dll" por "msvbvm60.dll"
Private Declare Function VarPtrArray Lib "msvbvm50.dll" Alias "VarPtr" (Ptr() As Any) As Long
Private Declare Function CallWindowProc Lib "user32.dll" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long


'Constantes que definen el estado de la barra.
Private Const fMASKCOLOR = 1
Private Const fAUTOSIZE = 2
Private Const fDRAWFOCUSRECT = 4

'Constantes para identificar los botones.
Private Const BUTTON_PREVIOUS = -2
Private Const BUTTON_NEXT = -1
Private Const NO_BUTTON = -3

'Constante que define el margen entre el texto o icono
'y los bordes.
Private Const MARGINSIZE = 3

'Constantes que definen estados internos de los botones.
Private Const BTN_VISIBLE = 1
Private Const BTN_SHOWABLE = 2
Private Const BTN_FULLVISIBLE = BTN_VISIBLE Or BTN_SHOWABLE

'Constante que define el color de la sombra del icono.
Private Const SHADOW_COLOR = &HC0C0C0

'Constantes de enumeracion que representan las posibles
'alineaciones de texto o imagen.
Public Enum eAlignment
 eLeft = 1
 eRight = 2
 eHCenter = 4
 eTop = 8
 eBottom = 16
 eVCenter = 32
End Enum

'Constantes de enumeracion que representan los tipos de
'botones de la barra.
Public Enum eButtonTypes
 eSeparator = 1
 eButton = 2
 eCheck = 4
 'eCheck = 0100 en binario
 'eOption = 1100 en binario
 'Implica que el tipo eOption comparte un bit con el
 'tipo eCheck, pero no con eSeparator o eButton.
 eOption = 12
End Enum

'Constantes de enumeracion que representan los estilos
'de un boton.
Public Enum eButtonStyles
 eFlat = 1
 eHot = 2
 e3D = 3
 eOwnerDrawn = 4
 eSkinned = 5
End Enum


'Constantes de enumeracion que reprensentan los estados
'de un boton.
Public Enum eButtonStates
 eNormal = 0
 eFocused = 2
 eOver = 1
 eDown = 4
 eDisabled = 8
End Enum

'Constantes para los offset de la skin de acuerdo al
'estado del boton.
Private Const BTN_SKN_NORMAL  As Long = 0
Private Const BTN_SKN_FOCUSED  As Long = 1
Private Const BTN_SKN_OVER  As Long = 2
Private Const BTN_SKN_DOWN  As Long = 3
Private Const BTN_SKN_DISABLED  As Long = 4

'Constantes de enumeracion para los tipo de relleno del
'boton.
Public Enum eFillMode
 eVerticalGradient
 eHorizontalGradient
 eTransparent
 eSolid
 ePatternFill
 eBlit
 eStretchBlit
End Enum

'Tipo de datos que almacena la informacion de cada boton.
Private Type tButton
 Text As String
 Icon As StdPicture
 Style As eButtonStyles
 State As eButtonStates
 ButtonType As eButtonTypes
 TextAlign As eAlignment
 IconAlign As eAlignment
 Tooltip As String
 Left As Long
 Top As Long
 Width As Long
 Height As Long
 'Funciona como la skin gral., tiene los 5 estados en
 'la imagen.
 Skin As StdPicture
 'Maskcolor de la skin y del Icon.
 MaskColor As Long
 Flags As Long
End Type

Private Type tDCData
 DC As Long
 OldBmp As Long
 OldPen As Long
 oldBrush As Long
 OldFont As Long
 CurBmp As Long
 CurPen As Long
 CurBrush As Long
 CurFont As Long
 HasBmp As Boolean
End Type

Private WithEvents m_Container As PictureBox
Attribute m_Container.VB_VarHelpID = -1
Private WithEvents m_Font As StdFont
Attribute m_Font.VB_VarHelpID = -1
'Indica el DC que contiene a la skin.
Private m_SkinDC As tDCData
'Contiene el DC del picturebox (solo por simplicidad)
Private m_DC As tDCData
'Contiene el DC de la mascara de la skin.
Private m_SkinMaskDC As tDCData
'Contiene el DC de BackBuffer
Private m_BackBuffer As tDCData
'Contiene un DC del tamao del picturebox para dibujar
'las skins particulares de los botones.
Private m_ButtonSkinDC As tDCData
'Indica la imagen original del Canvas.
Private m_Skin As StdPicture
'Indica el Ancho de la Skin.
Private m_SkinWidth As Long
'Indica el Alto de la Skin.
Private m_SkinHeight As Long
'Indican el ancho y alto del borde de la skin.
Private m_SkinBorderWidth(5) As Long
Private m_SkinBorderHeight(5) As Long
'Array que contiene los datos de los botones y separadores
Private m_Buttons() As tButton
'Cant. de botones y separadores que hay en la barra
Private m_nButtons As Long
'Indica el color de fondo de la barra.
Private m_BackColor As Long
'Indica el color primario de fondo de los botones para los estados
'Normal, Focused, Disabled, Over y Down.
Private m_BackColor1(5) As Long
'Indica el color secundario de fondo de los botones para los estados
'Normal, Focused, Disabled, Over y Down.
Private m_BackColor2(5) As Long
'Indica el color primario de texto de los botones para los estados
'Normal, Disabled, Over y Down.
Private m_TextColor1(5) As Long
'Indica el color secundario de texto de los botones para los estados
'Normal, Focused, Disabled, Over y Down.
Private m_TextColor2(5) As Long
'Indica el color de borde de los botones para los estados
'Normal, Focused, Disabled, Over y Down.
Private m_BorderColor(5) As Long
'Indica el ancho del borde.
Private m_BorderWidth As Long
'Indica las banderas que estan activadas.
Private m_BarFlags As Long
'Indica el color de transparencia de la skin.
Private m_MaskColor As Long
'Indica cual es el boton que esta presionado por el mouse.
Private m_ButtonDown As Long
'Indica el boton sobre el cual se encuentra el mouse.
Private m_ButtonOver As Long
'Indica el boton sobre el cual se encuentra el foco.
Private m_ButtonFocus As Long
'Variables que contienen los botones Anterior y Siguiente
Private m_ButtonPrevious As tButton
Private m_ButtonNext As tButton
'Indica el modo en que se dibuja la skin del boton
Private m_FillMode As Long
'Indica el efecto que tendra el texto del boton
Private m_FontEffect As Long
'Indican el alto y ancho por defecto de los botones.
Private m_DefaultButtonWidth As Long
Private m_DefaultButtonHeight As Long
'Indica el espacio horizontal que hay entre cada botn.
Private m_HorizontalButtonGap As Long
'Indica el espacio horizontal que hay entre el botn y la barra.
Private m_VerticalButtonGap As Long
'Contiene el patron con el que pintamos el fondo de un
'boton Check que no usa Skin.
Private m_CheckPatternBrush As Long
'Indica si la llamada para dibujar los botones proviene
'del procedimiento RedrawBar (es para evitar el flickering).
Private m_RedrawAllButtons As Boolean
'Indica si realmente actualizamos la barra o no en el
'picturebox.
Private m_LockUpdate As Boolean
'Indica el primer boton visible.
Private m_FirstVisibleButton As Long
'Indica la cantidad de botones visibles.
Private m_nVisibleButtons As Long

Public Event Click(Index As Long)
Public Event MouseDown(Index As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseMove(Index As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseUp(Index As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseEnter(Index As Long)
Public Event MouseLeave(Index As Long)
Public Event GotFocus(Index As Long)
Public Event LostFocus(Index As Long, Desc As String)
Public Event Paint() '(Index As Long)
Public Event Resize() '(Index As Long)
Public Event KeyDown(Index As Long, KeyCode As Integer, Shift As Integer)
Public Event KeyUp(Index As Long, KeyCode As Integer, Shift As Integer)
Public Event KeyPressed(Index As Long, KeyAscii As Integer)


'=============================================
'DEFINICION DE METODOS PUBLICOS
'=============================================

'Crea un nuevo boton para la barra.
'Devuelve el indice del boton.
Public Function AddButton(BtnType As eButtonTypes, Text As String, Optional Style As eButtonStyles = eFlat, Optional Tooltip As String = "", Optional Img As StdPicture, Optional TextAlignment As eAlignment = eRight Or eVCenter, Optional ImgAlignment As eAlignment = eLeft Or eVCenter, Optional State As eButtonStates = eNormal) As Long
 Dim dx As Long, dy As Long
 
 'Si la barra no fue creada o fue destruida, no agregamos
 'ningun boton.
 If (m_Container Is Nothing) Then
  AddButton = -1
  Exit Function
 End If
 ReDim Preserve m_Buttons(m_nButtons) As tButton
 With m_Buttons(m_nButtons)
  .Text = Text
  .Tooltip = Tooltip
  .TextAlign = TextAlignment
  .IconAlign = ImgAlignment
  .State = State
  .Style = Style
  .ButtonType = BtnType
  If (m_BarFlags And fAUTOSIZE) <> fAUTOSIZE Then
   .Height = m_DefaultButtonHeight
   .Width = m_DefaultButtonWidth
  Else
   If Not (Img Is Nothing) Then
    dx = m_Container.ScaleX(Img.Width)
    dy = m_Container.ScaleY(Img.Height)
   End If
   dx = dx + m_Container.TextWidth(.Text) + MARGINSIZE * 2
   dy = dy + m_Container.TextHeight(.Text) + MARGINSIZE * 2
   If Style = eSkinned Then
    dx = dx + m_SkinBorderWidth(0) * 2
    dy = dy + m_SkinBorderHeight(0) * 2
   Else
    dx = dx + m_BorderWidth * 2
    dy = dy + m_BorderWidth * 2
   End If
   .Width = dx
   .Height = dy
  End If
  .Top = m_VerticalButtonGap
  .Left = m_HorizontalButtonGap
  If m_nButtons > 0 Then
   .Left = .Left + m_Buttons(m_nButtons - 1).Left + m_Buttons(m_nButtons - 1).Width
  End If
  .Flags = BTN_FULLVISIBLE
  If BtnType = eSeparator Then
   Set .Skin = Img
   .Width = m_Container.ScaleX(.Skin.Width)
   .Height = m_Container.ScaleY(.Skin.Height)
  Else
   Set .Icon = Img
  End If
 End With
 AddButton = m_nButtons
' Debug.Print "AddButton " & m_nButtons & " - m_FirstVisibleButton = " & m_FirstVisibleButton
 m_nButtons = m_nButtons + 1
'' Debug.Print "RedrawBar de AddButton"
'' RedrawBar
''No es necesario redibujar toda la barra, ya que el
''boton se agrega ultimo en la barra, asi que los botones
''anteriores ya han sido dibujados.
' DrawButton m_nButtons - 1
 CheckVisibleButtons
End Function

'Elimina un boton o un separador de la barra.
'Devuelve la cantidad de botones y separadores.
Public Function RemoveButton(Indice As Long) As Long
 Dim i As Long
 
 If Indice >= 0 And Indice < m_nButtons Then
  If Indice < m_nButtons Then
   'Reordenamos el array.
'   CopyMemory m_Buttons(Indice), m_Buttons(Indice + 1), (m_nButtons - Indice) * Len(m_Buttons(Indice))
   For i = Indice To m_nButtons - 2
    m_Buttons(i) = m_Buttons(i + 1)
   Next i
  End If
  m_nButtons = m_nButtons - 1
  If m_nButtons > 1 Then
   ReDim Preserve m_Buttons(m_nButtons) As tButton
  End If
  RemoveButton = m_nButtons
'  Debug.Print "RedrawBar de RemoveButton"
  Debug.Print "RemoveButton - M_FIRSTVISIBLEBUTTON = " & m_FirstVisibleButton
  Debug.Print "RemoveButton - Indice = " & Indice
  If Indice < m_FirstVisibleButton Then
   m_FirstVisibleButton = m_FirstVisibleButton - 1
   UpdateButtonPos Indice, 0, False
  Else
   If Indice = m_FirstVisibleButton Then
    m_Buttons(Indice).Left = m_HorizontalButtonGap
    UpdateButtonPos Indice + 1, m_nButtons - 1, True
   Else
    UpdateButtonPos Indice, m_nButtons - 1, True
   End If
  End If
  CheckVisibleButtons
  RedrawBar
 End If
End Function

'Cambia de posicion el boton dado.
'Devuelve la cant. de botones en la barra.
Public Function MoveButton(Index As Long, Position As Long) As Long
 Dim Temp As tButton, i As Long
 
 'Si el indice del boton es valido.
 If Index >= 0 And Index < m_nButtons Then
  'Si la nueva posicion es valida.
  If Position >= 0 And Position < m_nButtons Then
   MoveButton = m_nButtons
   'Si es la misma posicion, no hacemos nada, salimos.
   If Index = Position Then
    Exit Function
   'Sino si la posicion es hacia la derecha
   ElseIf Index < Position And Index < (m_nButtons - 1) Then
    'Movemos el boton hacia la derecha
    Temp = m_Buttons(Index)
    For i = Index + 1 To Position
     m_Buttons(i - 1) = m_Buttons(i)
    Next i
    m_Buttons(Position) = Temp
    If Position >= m_FirstVisibleButton And Index < m_FirstVisibleButton Then
     m_Buttons(m_FirstVisibleButton).Left = m_HorizontalButtonGap
     If m_FirstVisibleButton > 0 Then UpdateButtonPos m_FirstVisibleButton - 1, 0, False
     If Position >= m_FirstVisibleButton Then UpdateButtonPos m_FirstVisibleButton + 1, m_nButtons - 1, True
    Else
     m_Buttons(Index).Left = m_Buttons(Position).Left
    UpdateButtonPos Index + 1, Position, (Position > Index)
    End If
   'Sino si la posicion es hacia la izquierda
   ElseIf Index > Position Then
'    Debug.Print "MoveButton - Boton " & Index & " a la posicion " & Position
    'Movemos el boton hacia la izquierda
    Temp = m_Buttons(Index)
    For i = (Index - 1) To Position Step -1
     m_Buttons(i + 1) = m_Buttons(i)
    Next i
    m_Buttons(Position) = Temp
'    Debug.Print "FirstVisibleButton = " & m_Buttons(m_FirstVisibleButton).Text
    If Position < m_FirstVisibleButton And Index >= m_FirstVisibleButton Then
    'Este If es lo mismo que decir: Si al cambiar el orden
    'de los botones, el primer boton visible no sigue siendo
    'el mismo, entonces:
     m_Buttons(m_FirstVisibleButton).Left = m_HorizontalButtonGap
     If m_FirstVisibleButton <= Index Then UpdateButtonPos m_FirstVisibleButton + 1, m_nButtons - 1, True
     If m_FirstVisibleButton > 0 Then UpdateButtonPos m_FirstVisibleButton - 1, 0, False
    Else
    'Si la posicion y el indice son ambos anteriores
    'o posteriores al primer boton visible, entonces:
     m_Buttons(Position).Left = m_Buttons(Position + 1).Left
     UpdateButtonPos Position + 1, Index, True '(Position < Index)
    End If
   End If
'   Debug.Print "RedrawBar de MoveButton"
'   Debug.Print "MoveButtons New Coords. (" & Index & ", " & Position & ") - FirstVisible = " & m_FirstVisibleButton
   For i = 0 To m_nButtons - 1
    Debug.Print m_Buttons(i).Text & " - m_Buttons(" & i & ").Left = " & m_Buttons(i).Left
   Next i
   Debug.Print
   CheckVisibleButtons
   RedrawBar
  End If
 End If
End Function

'Asocia el picturebox a la clase, creando la barra.
Public Function Create(ContainerControl As PictureBox) As Long
 Dim i As Long, SysColor As Long
 Dim Result As Boolean
 Dim mbi As BITMAPINFO
 Dim Color As RGBQUAD
 
 Set m_Container = ContainerControl
 m_Container.ScaleMode = vbPixels
 Create = m_Container.hwnd
 'Creamos un DC que vamos a utilizar como BackBuffer.
 Result = CloneDC(m_Container.hDC, m_Container.ScaleWidth, m_Container.ScaleHeight, m_BackBuffer)
 'Creamos un DC que vamos a utilizar para trabajar con
 'la skin.
 Result = CloneDC(0, 0, 0, m_SkinDC)
 'Creamos un DC que vamos a utilizar para trabajar con
 'la mascara de la skin.
 Result = CloneDC(0, 0, 0, m_SkinMaskDC)
 'Creamos un DC del tamao del picturebox para trabajar
 'con las skins particulares de los botones.
 Result = CloneDC(m_Container.hDC, m_Container.ScaleWidth, m_Container.ScaleHeight, m_ButtonSkinDC)
 
 m_DC.DC = m_Container.hDC
 If (m_Container.BackColor And &H80000000) = &H80000000 Then
 'Es un color del sistema
  SysColor = (m_Container.BackColor And &H7FFFFFFF)
  m_BackColor = GetSysColor(SysColor)
 Else
  m_BackColor = m_Container.BackColor
 End If
 For i = 0 To 5
  m_BackColor1(i) = m_BackColor
  m_TextColor1(i) = 0&
  m_TextColor2(i) = &HFFFFFF
 Next i
 'Creamos el patron del brush para los botones Check sin Skin.
 With mbi
  .bmiHeader.biSize = LenB(.bmiHeader)
  .bmiHeader.biBitCount = 32
  .bmiHeader.biHeight = 2
  .bmiHeader.biWidth = 2
  .bmiHeader.biPlanes = 1
  .bmiHeader.biCompression = BI_RGB
  .bmiColors(0) = m_BackColor
  .bmiColors(1) = RGB(255, 255, 255)
  .bmiColors(2) = RGB(255, 255, 255)
  .bmiColors(3) = m_BackColor
 End With
 m_CheckPatternBrush = CreateDIBPatternBrushPt(mbi, DIB_RGB_COLORS)
' Debug.Print "HBrush = " & HBrush

'Establecemos las coordenadas de los botones de navegacion.
 m_ButtonNext.Width = m_Container.TextWidth("<<") + (m_BorderWidth * 2) + (MARGINSIZE * 2)
 m_ButtonNext.Left = m_Container.ScaleWidth - m_HorizontalButtonGap - m_ButtonNext.Width
 m_ButtonNext.Top = m_VerticalButtonGap
 m_ButtonNext.Height = m_Container.ScaleHeight - (m_VerticalButtonGap * 2)
' With m_ButtonNext
'  Debug.Print "Button Next = (" & .Left & ", " & .Top & ") - (" & .Width & ", " & .Height & ")"
' End With
 'Establecemos el texto y su alineacion.
 m_ButtonNext.TextAlign = eLeft Or eVCenter
 m_ButtonNext.Text = ">>"
 'Establecemos el tipo de boton.
 m_ButtonNext.ButtonType = eButton
 m_ButtonNext.Style = e3D
 m_ButtonNext.State = eNormal
 
 m_ButtonPrevious.Left = m_ButtonNext.Left - m_HorizontalButtonGap - m_ButtonNext.Width
 m_ButtonPrevious.Width = m_ButtonNext.Width
 m_ButtonPrevious.Top = m_VerticalButtonGap
 m_ButtonPrevious.Height = m_Container.ScaleHeight - (m_VerticalButtonGap * 2)
' With m_ButtonPrevious
'  Debug.Print "Button Previous = (" & .Left & ", " & .Top & ") - (" & .Width & ", " & .Height & ")"
' End With
 
 'Establecemos el texto y su alineacion.
 m_ButtonPrevious.TextAlign = eLeft Or eVCenter
 m_ButtonPrevious.Text = "<<"
 'Establecemos el tipo de boton.
 m_ButtonPrevious.ButtonType = eButton
 m_ButtonPrevious.Style = e3D
 m_ButtonPrevious.State = eNormal
End Function

'Libera todos los objetos asociados a la clase.
Public Sub Destroy()
 Dim i As Long
 
 'Si no existe la barra, evitamos el error.
 If m_Container Is Nothing Then Exit Sub

 DestroyDC m_SkinDC
 DestroyDC m_SkinMaskDC
 DestroyDC m_BackBuffer
 DestroyDC m_ButtonSkinDC
 DeleteObject m_CheckPatternBrush
 Set m_Skin = Nothing
 Set m_Font = Nothing
 For i = 0 To m_nButtons - 1
  Set m_Buttons(i).Skin = Nothing
  Set m_Buttons(i).Icon = Nothing
 Next i
 m_nButtons = 0
 Erase m_Buttons
 Set m_Container = Nothing
End Sub

'Redibuja todo el control o el boton dado.
Public Sub Refresh(Optional ByVal BtnIndex As Long = NO_BUTTON)
 If BtnIndex = NO_BUTTON Then
'  Debug.Print "RedrawBar de Refresh"
  RedrawBar
 ElseIf BtnIndex >= 0 And BtnIndex < m_nButtons Then
  DrawButton BtnIndex
 End If
End Sub

'Mueve o redimensiona el control.
Public Sub Move(Left As Long, Top As Long, Width As Long, Height As Long)
 'Si no existe la barra, evitamos el error.
 If m_Container Is Nothing Then Exit Sub
 m_Container.Move Left, Top, Width, Height
End Sub

'Asigna la skin de los botones a la barra.
Public Function SetSkin(ByVal Img As StdPicture) As Boolean
 Dim Result As Long
 
 'Si no existe la barra, evitamos el error.
 If m_Container Is Nothing Then Exit Function
 
 With m_SkinDC
  If .DC = 0 Then
   SetSkin = False
  Else
   If Not (Img Is Nothing) Then
    Result = SelectObject(.DC, Img.handle)
    If .OldBmp = 0 Then .OldBmp = Result
    .CurBmp = Img.handle
    m_SkinWidth = m_Container.ScaleX(Img.Width)
    m_SkinHeight = m_Container.ScaleY(Img.Height)
    If CreateMaskImage(m_SkinDC, m_SkinMaskDC, m_SkinWidth, m_SkinHeight, m_MaskColor) Then
'     Debug.Print "La mascara fue creada satisfactoriamente."
    Else
'     Debug.Print "La mascara no pudo ser creada."
     SetSkin = False
     Exit Function
    End If
'    Debug.Print "RedrawBar de SetSkin"
    RedrawBar
   End If
   Set m_Skin = Img
   SetSkin = True
  End If
 End With
End Function

Public Function GetButtonBackColor(ByRef FirstColor As Long, ByRef SecondColor As Long, BtnState As eButtonStates) As Long
 FirstColor = m_BackColor1(BtnState)
 SecondColor = m_BackColor2(BtnState)
End Function

Public Function SetButtonBackColor(ByRef FirstColor As Long, ByRef SecondColor As Long, BtnState As eButtonStates) As Long
 Dim SysColor As Long
 Dim State As Long
 
 State = GetButtonStateSkin(BtnState)
 
 If (FirstColor And &H80000000) = &H80000000 Then
 'Es un color del sistema
  SysColor = (FirstColor And &H7FFFFFFF)
  FirstColor = GetSysColor(SysColor)
 End If
 m_BackColor1(State) = FirstColor
 
 If (SecondColor And &H80000000) = &H80000000 Then
 'Es un color del sistema
  SysColor = (SecondColor And &H7FFFFFFF)
  SecondColor = GetSysColor(SysColor)
 End If
 m_BackColor2(State) = SecondColor
' Debug.Print "RedrawBar de SetButtonBackColor"
 RedrawBar
End Function

Public Function GetButtonTextColor(ByRef FirstColor As Long, ByRef SecondColor As Long, BtnState As eButtonStates) As Long
 FirstColor = m_TextColor1(BtnState)
 SecondColor = m_TextColor2(BtnState)
End Function

Public Function SetButtonTextColor(ByRef FirstColor As Long, ByRef SecondColor As Long, BtnState As eButtonStates) As Long
 Dim SysColor As Long
 Dim State As Long
 
 State = GetButtonStateSkin(BtnState)
 If (FirstColor And &H80000000) = &H80000000 Then
 'Es un color del sistema
  SysColor = (FirstColor And &H7FFFFFFF)
  FirstColor = GetSysColor(SysColor)
 End If
 m_TextColor1(State) = FirstColor
 
 If (SecondColor And &H80000000) = &H80000000 Then
 'Es un color del sistema
  SysColor = (SecondColor And &H7FFFFFFF)
  SecondColor = GetSysColor(SysColor)
 End If
 m_TextColor2(State) = SecondColor
' Debug.Print "RedrawBar de SetButtonTextColor"
 RedrawBar
End Function

Public Function GetButtonBorderColor(ByRef Color As Long, BtnState As eButtonStates) As Long
 Color = m_BorderColor(BtnState)
 GetButtonBorderColor = m_BorderColor(BtnState)
End Function

Public Function SetButtonBorderColor(ByRef Color As Long, BtnState As eButtonStates) As Long
 Dim SysColor As Long
 Dim State As Long
 
 State = GetButtonStateSkin(BtnState)
 
 If (Color And &H80000000) = &H80000000 Then
 'Es un color del sistema
  SysColor = (Color And &H7FFFFFFF)
  Color = GetSysColor(SysColor)
 End If
 m_BorderColor(State) = Color
' Debug.Print "RedrawBar de SetButtonBorderColor"
 RedrawBar
End Function

'Modifica el estado de los botones.
Friend Function SetButtonState(ByVal Index As Long, State As eButtonStates, SetState As Boolean) As eButtonStates
 Dim i As Long
 
 If Index >= 0 And Index < m_nButtons Then
  'Si a un boton tipo Option se le esta estableciendo
  'el estado eDown a True, buscamos el boton del grupo
  'que actualmente tiene el estado eDown a True y se lo
  'ponemos en False.
  If (m_Buttons(Index).ButtonType = eOption) And (State = eDown) Then
   If SetState Then
    'Chequeamos hacia la izquierda del boton
    For i = Index To 0 Step -1
     With m_Buttons(i)
      If .ButtonType = eOption Then
       If (.State And eDown) Then
        .State = .State And (Not eDown)
        DrawButton i
        GoTo SetCurState
       End If
      Else
       Exit For
      End If
     End With
    Next i
    'Chequeamos hacia la derecha del boton
    For i = Index To m_nButtons - 1
     With m_Buttons(i)
      If .ButtonType = eOption Then
       'Modificamos el estado si el boton option esta
       'siendo establecido a presionado.
       If (.State And eDown) Then
        .State = .State And (Not eDown)
        DrawButton i
        GoTo SetCurState
       End If
      Else
       Exit For
      End If
     End With
    Next i
   Else
    Exit Function
   End If
  End If
  
SetCurState:

  If SetState Then
   m_Buttons(Index).State = m_Buttons(Index).State Or State
  Else
   m_Buttons(Index).State = m_Buttons(Index).State And (Not State)
  End If
'  Debug.Print "SetButtonState (&H" & Hex(State) & ") = &H" & Hex(m_Buttons(Index).State)
  SetButtonState = m_Buttons(Index).State
 ElseIf Index = BUTTON_PREVIOUS Then
  If SetState Then
   m_ButtonPrevious.State = m_ButtonPrevious.State Or State
  Else
   m_ButtonPrevious.State = m_ButtonPrevious.State And (Not State)
  End If
'  Debug.Print "SetButtonState (&H" & Hex(State) & ") = &H" & Hex(m_ButtonPrevious.State)
  SetButtonState = m_ButtonPrevious.State
 ElseIf Index = BUTTON_NEXT Then
  If SetState Then
   m_ButtonNext.State = m_ButtonNext.State Or State
  Else
   m_ButtonNext.State = m_ButtonNext.State And (Not State)
  End If
'  Debug.Print "SetButtonState (&H" & Hex(State) & ") = &H" & Hex(m_ButtonNext.State)
  SetButtonState = m_ButtonNext.State
 Else
  SetButtonState = -1
  Exit Function
 End If
End Function

'Establece el tamao del boton.
'Devuelve si es visible o no.
Public Function SetButtonSize(ByVal Index As Long, Optional ByVal W As Long = 0, Optional ByVal H As Long = 0) As Boolean
 If Index >= 0 And Index < m_nButtons Then
  If W > 0 Then m_Buttons(Index).Width = W
  If H > 0 Then m_Buttons(Index).Height = H
  UpdateButtonPos Index, m_nButtons - 1, True
  CheckVisibleButtons
  SetButtonSize = (m_Buttons(Index).Flags And BTN_FULLVISIBLE)
'  Debug.Print "RedrawBar en SetButtonSize"
'  RedrawBar
 End If
End Function

'Establece la skin particular del boton dado.
Public Function SetButtonSkin(ByVal Index As Long, ByVal BtnSkin As StdPicture, Optional ByVal SkinMaskColor As Long = -1) As Boolean
 If Index >= 0 And Index < m_nButtons Then
  Set m_Buttons(Index).Skin = BtnSkin
  If SkinMaskColor = -1 Then SkinMaskColor = m_MaskColor
  m_Buttons(Index).MaskColor = SkinMaskColor
  DrawButton Index
 End If
End Function

Public Sub SetFocus(Optional ByVal Index As Long = NO_BUTTON)
 m_Container.SetFocus
 If Index > NO_BUTTON Then
  Me.SetButtonState m_ButtonFocus, eFocused, False
  DrawButton m_ButtonFocus
  m_ButtonFocus = Index
  Me.SetButtonState m_ButtonFocus, eFocused, True
 End If
 DrawButton m_ButtonFocus
End Sub

'=============================================
'DEFINICION DE EVENTOS PRIVADOS
'=============================================

Private Sub Class_Initialize()
 m_BarFlags = fMASKCOLOR Or fDRAWFOCUSRECT
 m_FillMode = eSolid
 m_BorderWidth = 1
 m_ButtonOver = NO_BUTTON
 m_ButtonDown = NO_BUTTON
 m_ButtonFocus = NO_BUTTON
 m_DefaultButtonWidth = 80
 m_DefaultButtonHeight = 40
 m_VerticalButtonGap = 3
 m_HorizontalButtonGap = 3
 m_MaskColor = -1
End Sub

Private Sub Class_Terminate()
 Me.Destroy
End Sub

Private Sub m_Container_GotFocus()
' Debug.Print "m_ButtonFocus en Got_Focus = " & m_ButtonFocus & " Has the Focus? = " & CBool(Me.ButtonState(m_ButtonFocus) And eFocused)
 If (Me.ButtonState(m_ButtonFocus) And eDisabled) Then Exit Sub
 If m_ButtonFocus >= 0 And m_ButtonFocus < m_nButtons Then
  'Dibujamos el Focus Rect
  DrawButton m_ButtonFocus
'  RaiseEvent GotFocus(m_ButtonFocus)
 End If
End Sub

Private Sub m_Container_KeyDown(KeyCode As Integer, Shift As Integer)
 Dim NextButton As Long
'EXISTE UN PROBLEMA CUANDO UN COMMAND BUTTON TIENE LA
'PROPIEDAD DEFAULT A TRUE, EL PICTUREBOX NO RECIBE EL
'EVENTO KEYDOWN CON VBKEYRETURN, SI ES FALSE NO HAY
'NINGUN PROBLEMA.
' Debug.Print "Enter KeyDown"
' Debug.Print "m_ButtonFocus = " & m_ButtonFocus
 If KeyCode = vbKeyReturn Or KeyCode = vbKeySpace Then
  If (Me.ButtonState(m_ButtonFocus) And eDisabled) Then Exit Sub
   'Si ya hay un boton presionado, no hacemos nada.
  If m_ButtonDown > NO_BUTTON Then Exit Sub
  If m_ButtonFocus > NO_BUTTON Then
   m_ButtonDown = m_ButtonFocus
'   Debug.Print "Key Down con Space, m_ButtonDown = " & m_ButtonDown
   If (Me.ButtonType(m_ButtonDown) And eCheck) <> eCheck Then
    Me.SetButtonState m_ButtonDown, eDown, True
   Else
    'Al boton tipo Check le invertimos el estado
    Me.SetButtonState m_ButtonDown, eDown, Not CBool(Me.ButtonState(m_ButtonDown) And eDown)
   End If
   DrawButton m_ButtonDown
   'Evento con el teclado.
   RaiseEvent KeyDown(m_ButtonDown, KeyCode, Shift)
  End If
 ElseIf KeyCode = vbKeyLeft Then
  If m_ButtonFocus < 0 Then Exit Sub
  NextButton = NextAvailableButton(m_ButtonFocus - 1, 0)
  If NextButton = NO_BUTTON Then Exit Sub
'  Debug.Print "Se presiono la flecha izq."
  'Quitamos el foco del boton actual.
  Me.SetButtonState m_ButtonFocus, eFocused, False
  DrawButton m_ButtonFocus
  RaiseEvent KeyDown(m_ButtonFocus, KeyCode, Shift)
  RaiseEvent LostFocus(m_ButtonFocus, "KeyDown")
  m_ButtonFocus = NextButton
  Me.SetButtonState m_ButtonFocus, eFocused, True
  DrawButton m_ButtonFocus
  RaiseEvent GotFocus(m_ButtonFocus)
 ElseIf KeyCode = vbKeyRight Then
  If m_ButtonFocus < 0 Then Exit Sub
  NextButton = NextAvailableButton(m_ButtonFocus + 1, m_nButtons - 1)
  If NextButton = NO_BUTTON Then Exit Sub
'  Debug.Print "Se presiono la flecha der."
  'Quitamos el foco del boton actual.
  Me.SetButtonState m_ButtonFocus, eFocused, False
  DrawButton m_ButtonFocus
  RaiseEvent KeyDown(m_ButtonFocus, KeyCode, Shift)
  RaiseEvent LostFocus(m_ButtonFocus, "KeyDown")
  m_ButtonFocus = NextButton
  Me.SetButtonState m_ButtonFocus, eFocused, True
  DrawButton m_ButtonFocus
  RaiseEvent GotFocus(m_ButtonFocus)
 End If

End Sub

Private Sub m_Container_KeyPress(KeyAscii As Integer)
 If m_ButtonFocus >= 0 Then
  RaiseEvent KeyPressed(m_ButtonFocus, KeyAscii)
 End If
End Sub

Private Sub m_Container_KeyUp(KeyCode As Integer, Shift As Integer)
 If (Me.ButtonState(m_ButtonFocus) And eDisabled) Then Exit Sub
 If KeyCode = vbKeyReturn Or KeyCode = vbKeySpace Then
  If m_ButtonDown > NO_BUTTON Then
'   Debug.Print "Key Up con Space, m_ButtonDown = " & m_ButtonDown
   If (Me.ButtonType(m_ButtonDown) And eCheck) <> eCheck Then
    Me.SetButtonState m_ButtonDown, eDown, False
   End If
   m_ButtonFocus = m_ButtonDown
   DrawButton m_ButtonDown
   RaiseEvent Click(m_ButtonDown)
   'Agregamos la funcionalidad de los botones de navegacion.
   If m_ButtonDown = BUTTON_PREVIOUS Then
    m_FirstVisibleButton = m_FirstVisibleButton - 1
    m_Buttons(m_FirstVisibleButton).Left = m_HorizontalButtonGap 'm_Buttons(m_FirstVisibleButton).Left + m_Buttons(m_FirstVisibleButton).Width
    UpdateButtonPos m_FirstVisibleButton + 1, m_nButtons - 1, True
    UpdateButtonPos m_FirstVisibleButton, 0, False
    CheckVisibleButtons
   ElseIf m_ButtonDown = BUTTON_NEXT Then
'    m_Buttons(m_FirstVisibleButton).Left = m_Buttons(m_FirstVisibleButton).Left - m_Buttons(m_FirstVisibleButton).Width
    m_FirstVisibleButton = m_FirstVisibleButton + 1
    m_Buttons(m_FirstVisibleButton).Left = m_HorizontalButtonGap
    UpdateButtonPos m_FirstVisibleButton - 1, 0, False
    UpdateButtonPos m_FirstVisibleButton, m_nButtons - 1, True
    CheckVisibleButtons
   End If
  'Evento con el teclado.
   RaiseEvent KeyUp(m_ButtonDown, KeyCode, Shift)
   m_ButtonDown = NO_BUTTON
  End If
 End If

End Sub

Private Sub m_Container_LostFocus()
 Dim NextBtnFocus As Long
 Dim i As Long, Result As Long
 
 If IsKeyDown(vbKeyTab) Then
  If m_ButtonFocus < 0 Then Exit Sub
  NextBtnFocus = NextAvailableButton(m_ButtonFocus + 1, m_nButtons - 1)
  If NextBtnFocus <> NO_BUTTON Then
   'Borramos el Focus Rect del boton actual.
   Me.SetButtonState m_ButtonFocus, eFocused, False
   DrawButton m_ButtonFocus
   RaiseEvent LostFocus(m_ButtonFocus, "LostFocus")
'   Debug.Print "m_ButtonFocus en Lost_Focus = " & m_ButtonFocus & " Has the Focus? = " & CBool(Me.ButtonState(m_ButtonFocus) And eFocused)
   m_ButtonFocus = NextBtnFocus
   Me.SetButtonState m_ButtonFocus, eFocused, True
   m_Container.SetFocus
   RaiseEvent GotFocus(m_ButtonFocus)
  Else
   'Si m_Container no tiene el foco, dibujamos el boton
   'sin foco.
   DrawButton m_ButtonFocus
'   RaiseEvent LostFocus(m_ButtonFocus, "LostFocus")
  End If
' Else
'  RaiseEvent LostFocus
 End If
End Sub

Private Sub m_Container_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
 Dim TempBtn As Long
 
' Debug.Print "mOUSE DOWN"
 TempBtn = GetButtonCapture(CLng(X), CLng(Y))
 If Button = vbLeftButton Then
  If TempBtn > NO_BUTTON Then
'    If TempBtn = BUTTON_PREVIOUS Then
'     Debug.Print "m_ButtonDown = BUTTON_PREVIOUS is disabled? " & CBool(Me.ButtonState(TempBtn) And eDisabled)
'    ElseIf TempBtn = BUTTON_NEXT Then
'     Debug.Print "m_ButtonDown = BUTTON_NEXT is disabled? " & CBool(Me.ButtonState(TempBtn) And eDisabled)
'    End If
   
   If (Me.ButtonState(TempBtn) And eDisabled) Then Exit Sub
    m_ButtonDown = TempBtn
'   Debug.Print "Button Pressed = " & m_ButtonDown
   If (Me.ButtonType(m_ButtonDown) And eCheck) <> eCheck Then
    Me.SetButtonState m_ButtonDown, eDown, True
   Else
    'Al boton tipo Check le invertimos el estado
'    Debug.Print "Before changing, Check Button State is Down? = " & CBool(Me.ButtonState(m_ButtonDown) And eDown)
    Me.SetButtonState m_ButtonDown, eDown, Not CBool(Me.ButtonState(m_ButtonDown) And eDown)
'    Debug.Print "After changing, Check Button State is Down? = " & CBool(Me.ButtonState(m_ButtonDown) And eDown)
   End If
    'Quitamos el foco al boton anterior
    If m_ButtonFocus > NO_BUTTON Then
     Me.SetButtonState m_ButtonFocus, eFocused, False
     DrawButton m_ButtonFocus
     RaiseEvent LostFocus(m_ButtonFocus, "MouseDown")
    End If
    'Agregamos el foco al boton actual
    Me.SetButtonState m_ButtonDown, eFocused, True
    m_ButtonFocus = m_ButtonDown
'    Debug.Print "m_ButtonFocus en Mouse_Down = " & m_ButtonFocus
    DrawButton m_ButtonDown
    RaiseEvent GotFocus(m_ButtonFocus)
'   Debug.Print "MouseDown in x = " & x & ", y = " & y
   'Evento con el boton izquierdo del mouse.
   RaiseEvent MouseDown(m_ButtonDown, Button, Shift, X, Y)
  End If
 Else
  If (Me.ButtonState(TempBtn) And eDisabled) Then Exit Sub
  'Evento con el boton derecho o medio del mouse.
  RaiseEvent MouseDown(m_ButtonDown, Button, Shift, X, Y)
 End If
End Sub

Private Sub m_Container_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
 Dim ButtonIndex As Long
 
 
 'Obtenemos el indice del boton sobre el cual esta el
 'puntero del mouse.
 ButtonIndex = GetButtonCapture(CLng(X), CLng(Y))
 'Chequeamos el suceso Over
 If m_ButtonOver = ButtonIndex Then
  Exit Sub
 End If

' If ButtonIndex = BUTTON_PREVIOUS Then
'  Debug.Print "Mouse Over Button Previous"
' ElseIf ButtonIndex = BUTTON_NEXT Then
'  Debug.Print "Mouse Over Button Next"
' End If
 If (Me.ButtonState(ButtonIndex) And eDisabled) Then Exit Sub

' Debug.Print "m_ButtonDown = " & m_ButtonDown
' Debug.Print "Button with Capture = " & ButtonIndex
' Debug.Print "Button with Focus = " & m_ButtonFocus
 'Si estamos presionado el boton del mouse
 If Button = vbLeftButton Then
  'Si hay algun boton presionado
  If m_ButtonDown > NO_BUTTON Then
   'Si el boton presionado es distinto del que tiene
   'la captura del mouse, quitamos su estado Down.
   If m_ButtonDown <> ButtonIndex Then
    'Supuestamente es el mismo boton que m_ButtonOver.
    Me.SetButtonState m_ButtonDown, eDown, False
    m_ButtonDown = NO_BUTTON
   Else
   'sino si el boton con la captura es el mismo que el
   'que tiene el foco, ponemos su estado en Down.
    If m_ButtonFocus = ButtonIndex Then
     Me.SetButtonState m_ButtonDown, eDown, True
     m_ButtonDown = m_ButtonFocus
    End If
   End If
  End If
 End If
 
 'Si algun boton tiene el Over, se lo quitamos
 If m_ButtonOver > NO_BUTTON Then
  Me.SetButtonState m_ButtonOver, eOver, False
  DrawButton m_ButtonOver
  'Solo generamos estos eventos para los botones que
  'agrega el usuario.
  If m_ButtonOver >= 0 Then
'   Debug.Print "MouseLeave " & m_ButtonOver & " in x = " & x & ", y = " & y
   RaiseEvent MouseLeave(m_ButtonOver)
  End If
 End If
 'Si algun boton consiguio el Over, se lo agregamos
 If ButtonIndex > NO_BUTTON Then
  Me.SetButtonState ButtonIndex, eOver, True
  DrawButton ButtonIndex
  'En MouseEnter le agregamos el tooltip
  If ButtonIndex >= 0 Then
   m_Container.ToolTipText = m_Buttons(ButtonIndex).Tooltip
  End If
'  Debug.Print "MouseOver Boton " & ButtonIndex
  'Solo generamos estos eventos para los botones que
  'agrega el usuario.
  If ButtonIndex >= 0 Then
   RaiseEvent MouseEnter(ButtonIndex)
'  Debug.Print "MouseEnter " & ButtonIndex & " in x = " & x & ", y = " & y
  End If
 Else
  'Si no hay ningun boton con la captura, quitamos el
  'texto del tooltip.
  m_Container.ToolTipText = ""
 End If
 m_ButtonOver = ButtonIndex
End Sub

Private Sub m_Container_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
 Dim ButtonIndex As Long
 
 ButtonIndex = GetButtonCapture(CLng(X), CLng(Y))
 If Button = vbLeftButton Then
 'Si es un boton agregado de la barra.
  If ButtonIndex > NO_BUTTON Then
   If (Me.ButtonState(ButtonIndex) And eDisabled) Then Exit Sub
   'Si el boton del Mouse_Down es el mismo del Mouse_Up
   If m_ButtonDown = ButtonIndex Then
    If (Me.ButtonType(m_ButtonDown) And eCheck) <> eCheck Then
     Me.SetButtonState m_ButtonDown, eDown, False
    End If
    DrawButton m_ButtonDown
    RaiseEvent Click(ButtonIndex)
   End If
   'Agregamos la funcionalidad de los botones de navegacion.
   If m_ButtonDown = BUTTON_PREVIOUS Then
    m_FirstVisibleButton = m_FirstVisibleButton - 1
    m_Buttons(m_FirstVisibleButton).Left = m_HorizontalButtonGap 'm_Buttons(m_FirstVisibleButton).Left + m_Buttons(m_FirstVisibleButton).Width
    UpdateButtonPos m_FirstVisibleButton + 1, m_nButtons - 1, True
    UpdateButtonPos m_FirstVisibleButton, 0, False
    CheckVisibleButtons
   ElseIf m_ButtonDown = BUTTON_NEXT Then
'    m_Buttons(m_FirstVisibleButton).Left = m_Buttons(m_FirstVisibleButton).Left - m_Buttons(m_FirstVisibleButton).Width
    m_FirstVisibleButton = m_FirstVisibleButton + 1
    m_Buttons(m_FirstVisibleButton).Left = m_HorizontalButtonGap
    UpdateButtonPos m_FirstVisibleButton - 1, 0, False
    UpdateButtonPos m_FirstVisibleButton, m_nButtons - 1, True
    Debug.Print "M_FIRSTVISIBLEBUTTON = " & m_FirstVisibleButton
    CheckVisibleButtons
   End If
   'Evento con el boton izquierdo del mouse.
   RaiseEvent MouseUp(ButtonIndex, Button, Shift, X, Y)
   m_ButtonDown = NO_BUTTON
  End If
 Else
  If (Me.ButtonState(ButtonIndex) And eDisabled) Then Exit Sub
  'Evento con el boton derecho o medio del mouse.
  RaiseEvent MouseUp(ButtonIndex, Button, Shift, X, Y)
 End If
End Sub

Private Sub m_Container_Paint()
' Debug.Print "m_Container_Paint event"
' Debug.Print "RedrawBar de Paint"
 RedrawBar
 RaiseEvent Paint
End Sub

Private Sub m_Container_Resize()
 ResizeDC m_BackBuffer, m_Container.ScaleWidth, m_Container.ScaleHeight
 ResizeDC m_ButtonSkinDC, m_Container.ScaleWidth, m_Container.ScaleHeight
'Establecemos las coordenadas de los botones de navegacion.
 m_ButtonNext.Left = m_Container.ScaleWidth - m_HorizontalButtonGap - m_ButtonNext.Width
 m_ButtonNext.Top = m_VerticalButtonGap
 m_ButtonNext.Height = m_Container.ScaleHeight - (m_VerticalButtonGap * 2)
 
 m_ButtonPrevious.Left = m_ButtonNext.Left - m_HorizontalButtonGap - m_ButtonNext.Width
 m_ButtonPrevious.Top = m_VerticalButtonGap
 m_ButtonPrevious.Height = m_Container.ScaleHeight - (m_VerticalButtonGap * 2)

' RedrawBar
 RaiseEvent Resize
End Sub

Private Sub m_Font_FontChanged(ByVal PropertyName As String)
 Set m_Container.Font = m_Font
' Debug.Print "RedrawBar de FontChanged"
 RedrawBar
End Sub

'=============================================
'DEFINICION DE PROPIEDADES PUBLICAS
'=============================================

'Indica si actualizamos la barra o no.
Public Property Get LockUpdate() As Boolean
 LockUpdate = m_LockUpdate
End Property

'Indica si actualizamos la barra o no.
Public Property Let LockUpdate(ByVal NuevoValor As Boolean)
 m_LockUpdate = NuevoValor
 If Not NuevoValor Then
'  Debug.Print "RedrawBar de LockUpdate"
  RedrawBar
 End If
End Property


'Indica el espacio entre cada boton (en pixeles).
Public Property Get HorizontalButtonGap() As Long
 HorizontalButtonGap = m_HorizontalButtonGap
End Property

'Indica el espacio entre cada boton (en pixeles).
Public Property Let HorizontalButtonGap(ByVal NuevoValor As Long)
 m_HorizontalButtonGap = NuevoValor
' Debug.Print "RedrawBar de HorizontalButtonGap"
 RedrawBar
End Property

'Indica el espacio entre cada boton (en pixeles).
Public Property edraxeles).
Public c End If  CheckVisibleButtonstonIndex = GetButtonCapture(CLng(X)ttonGap * 2)
XstonIndex =own.
 X)ttonGap * 2)
XstonIndex =own.
 X)ttonGap * 2)
XstonInde(m_ButtonDButto2mcus >= 0 Thep * 2)
XstapturebrY))
 If Button eDowntre cadaNdth
ibleButtonstonIndex = GeturebrY))
 sropertA cada bot

'onGaer_Paint event"
' Debug.Print "RedrawBar de Paint"
 Rtate) & "0 Thep * 2)t

'onGaer_Pain_tonNext.Left = a e o no.
Public Function SetButtonSize(ByVal Index As Long, Optional ByVal W As Long = 0, Optional ByVal H As Long = 0) As Boolean
 If Index >= 0 And Index < m_nButtons Then
  If W > 0 Then m_Buttons(Index).Width = W
  If H > 0 Then m_Buttons(IndeHlean
 If Index >= 0 And Ina_nButns ThenseEvent Moui=.Width nt"
 RedrawBar
 RaiseEvent Paint
End Sub

Private utto2mcus e(m_ButtonFocus) And eFocused)t FunonOver, eOTRedrawBar de Paint As IntegelUis*,Gpz eOTRedrawBar de Paint e utto2mcus e(m_ButtonFocus) And eFocusev,nNext.l Sub
   'Si uttonDxltegelIndex).Tooltip
  tate) nDxlteger.ScaleX(Ionsiguio el Over, se lo agregamos
 If ButtonTa barra o no.
Public Propertyn - 1
    m_Buttons(m_FirstVii_ButtstonIndun boton
   'mt = d).Tooltip
  tate) nDxlt Img.h= d) If
b.
Public Propertynf Index >= 0 And Index < m_nButtons Then
  If W > 0 The).
Public Property LsizeDC 
Public Propertynf Indeef FirstetButtonCapture(r de Paint"
 Rtate) & deButtons
   End If

Private CTRUE, ght
 ResizeDC m_ButtonSkinDC, m_Container.ScaleWidth, m_Container.ScaleHeight
'Establecemos las coordenadas de_FirstVisibleB>ev,nNeir.ScaleHeign = m_nButtons
'rtical(CIndex,ittonDx Ref Index m_TextCon = m_IB_RGB_Cah, beHeight
'EY))
 rtyn - 1
    m_yn - 1
 
    m_yn  Y))
 If Button = vbLeftButight
MHedrawBar
End Sub

'===== m_ynnnnnByVmos las coordennButtons - ate)snt"
 Rteign = m_nButFm_Horizons - ate)snt"
 Rteign = m_nButFmropertynf Ilos n(m_ButtonD(m_ButtonD(m_ButtonD(m_ButtonD(m_ButtonD(m_ButtonD(m_ButtonD(m_ButtonD(m_ButtonD(m_Bu

'IndicaButtonD(m_BuEnd Sub

'===== _RGB_C_ButtonD(m_ButtonD(m_ButtonD=== m_ynnnnnByVmos ligjnD(m_ButtonDnFocus uttonDX

'onGaer_Pain_tonNext.Left = a e o no.
Public Function SetButtonSize(ByVal Index As Long, Optional ByVal Color As Long, BtnStIndex < m_n) As Ls(m_ButtonD(m_ uttonDX

'L,h_ynnnnnByVmolL      If .ButtonType = enByty LsizeDC 
Public Propn   Debug.Print True
    Else
     m_Buttons(Index).Left sS)nFocus uttonDX

'onGaer_Pain_tonNext.LefILefILByVal Index As Long, Optional ByVal Color nH,:mZed, False
  DrawButton m_ButtonFocus
  RaiseEvent KeyDown(m_ButtonFocus, KeyCodeXlse
  'Si algun botonalgunonF0nalgunonF0lse
  'Si algun  colmZed,odeXlse
a.l estado
  ate = mvoValor
' Dhacia la izquie) 'Si algun que el
lgun que elionNexs(ContainerContai onNexs(Cot
 RedrawBar
 RaiseEvent Paint
End Sub

Priv_FirstVisi vbLeftButton Then
  If TempBtn >nNexs(Cot
 Rtons
'rtical(C& deButtons
   E(_Buttonocus
  Ra PrAs Boolean
 If Index >= 0  _ButtonD(m_BHi)utton   'Si algnm_ynnnie) 'Si algunal ByVaem_nButFmropertynf Ilos n(m_ButtonD(m_ButtonD(m_ButtonD(m_ButtonD(m_ButtonD(m_ButtonD(m_ButtonD(m_ButtonD(m_ButtonkButtonDbot(m_ButtonkButtonDbot(m_ButtonkButm_ButtonD(m_ButtonD(m_Bu= m_nButFmropn(m_ButtonFocus, KeyCodewn(m_6uttoBtnStIn   Es
   xs(Coxs(Con wn(m_6"
 RtadonIndutFmropertynf Ilos n(m_BUTTON Then
   'a Fal& Indice
  PREVIOUSd0nf Ilos us
  Raise_NEXT Then
 > Index)
    End If
 s(m_Bice
  PREVIOUtoneButtonD(m_Button > , se lo agregamos
 If ButtonTa barra o no m_BuickUpda2o agregamos
 If ButtonTa barra o no m_BuickUpenButFmropn(m_BuD(m_ButtonD(m_ButtonD=== m_ynnnnnByVmos ligjnD(m_ButtonDnFocus uttonDX

'onGaer_Pain_tonNext.Left = a e o no.
Public Function SetButtonSize(ByVal Index As Long, Optional ByVal Color As Long, BtnStIndex < m_n) As Ls(m_ButtonD(m_ uttonDX

'L,h_ynnnnnByVmol=Ple)
 DgDowntre anD(h_ynnDx Ref InR p,, KeyCode, Shift)
  RaionnDxButtonTa Ndth
ibleButtonstonIndex = GeturebrY))
 sropertA cada botRhByVal ColoorizontalButtonGap = NuevBs        GoT GoT GoT GoT GobleBe*S PUBLICAS
'=======si vbLeftBu >nNexmlgunaSyVal Coloorndex = Geturh nt"
 Red Ilos n( = NuevBs   s prttonIndc
  If m_ButIndc
  e.ButDD2ngle)
nIndex) And eDisabl_BuEnd Sub

'===== _RGB_C_ButtonD(c
  If m_ButIndc
  e.ButDD2ngle)
nIndex) And eDisabl_BuEnd Sub

'===== _RGB_C  
 DgDowntre anD( Then
uttonOve 
   ElseIf li > NO_BUTTON Then
li > NO_BUTal ByVpertLeft, Top, Width, Height
End Sub

'Asigna la skin de losidth, HeGe HoreAsabl_BuEnd Sub

'===iado
  ate = AS
 Then
reAttonD(m_Bu Button, Shift, X, Y)
   m_Buttone losidthLntegelUis*,Gpz eOreamos un DC que vamoseckPar sropersbEo no m_
Public PropeEeckPar s ttonD==wn in xeAsabl_Bum_rH'a Fal& Indi
Hng
 
estado dmYtl& Indivamosic FunctmBft = mtonD(m_Button > , se lo agregamos
 If ButtonTa barra o no m_BuickUpda2o agregamos
 If ButtonTa barra o no  End If
E Boolean)
 m_LockUpdate = Nu'L,h_cemos el tiaint"
 Rtate) & deBd).
Public c 'EstablButton n = m_iner_BuickUpda2ore anD(xt.l Sub
n
uttonOve 
   ElseIf lxt.Left = a.Butttton > , se lo agregamos
 If ButtonTa barra otonTa Ndth
sropeDThep * 2)t
e losidthLntderecas sax >= 0  _ButtonD(m_BHd eDaTON Then
   ado
  at_e HoreAsab'tonDown
   'Evento con el Evento con = a.Butttton > , se lo agxeAsabl_Bum_rH'a Fal& Inrra otonTa NdonGaer_Pain_ )abl_Bum_rH'a Fal& SD( ons
  rbleButton = m_Firsm_B = a.B
  at_e HoreAsab'tte =uttonFocus
= a.Butttton > , sHoreAs>sm_B = a.B
  at_e HoreAsab'tte =uttonFocus
pe HoreAsab'tte =uttonFoc= vbLeftButton Then
 'Si es un boton agregado de la barruttonPrevious.HEto con el Evento con = aint "Rka& Inrra'tonDown
   'Evento con el Evento cotonFoc= vbLeftButton Thenon Thenon TheneftButtl.ng
 
 'Si no existe la barra, evitamos el error.
 If m_Container Is Nothing Then Exit Function
 
 With XIs No6e_B = a.B
  aThen
reAttMo con =Redra_BuEnd Sub

'===== _RGB_C_ButtorruttonPrint"
 Rtate) & deBd).
Publi
Redr.PriFmr_Buttong'===== _RG6e_B = a.B
  aThen
reAttMo con =Redra_BuEndtnSkin
  If S.
PubbtonFoc= vb pAttMo coim Nm_BHd eDaTONng, Topbstroy'Si no bbtonFooV cotoMo coim Nm_B If
 End If

End Sub
dtnSkin
  If S.
PubbtocotoMo Le.Bunebli
RedS Ndth
ibn Setnd Sub
CloneDC(0, 0, 0, m_SkinMaskDC)
 'Creamos un DC del tamao del picturebox paraIf
 s(lYt InrraRedrButtonolean)
 m_LntrecGe HoreAsabtttoX n = mnd Sub
CkDC)
c(m_BHi)uttoon ateButtcdrawBar
 RaiseEvent Paint
2ngle)
nIndexThen
 Xo
  ate = AS
 T ate = AS
 m_ButtonD(mocus) And er Is Notamosd eDisabl_BuEnd Sub
OpntChaoreAbl_Bgle)
 elenon Thenon ThenefFl_B (Not State)
  End Ifn = m_Firsm_nt "ButtntChaoreAblS
 m_t "ButtntChaoreAblS
 , sHoreAs>smThenon Thenef coim Nns
  rbleButton = m_Firs > Ndateenadas de lo  Debug.Print "M_FIRSTVISIB=ElseIf li > NO)
' Debuenadas de lo  DebutonD(m_ebutoDebuednd Sub

'===== _RGB_ ThentonDown
End Sub
e(inFocus = NextAvao.
  If m_BhentonDowny"r para trabaj "ButtThenon TheB(255, 255, 255)
  .bmiColoa los botoAEaiseEve
EnThentonDown
dMdex To m_nButtons - nnByVmos 'Evento con elm_ButIndc
  e.ButDD2ngle)
nItte =uttonFocus

 If m_BueREnThentonDo)
 Set m_CotDD2ng2Omos
 IftonFocus

 If m_BueREnThentonDo)
c'Xcoim Nm_B If
 End If

End SMrdateBS er Is Notamosd eDisabl_BuEnd Sub
OpntCordenadas de los botones de navegacne el g, Topoltip
  tBJIndc
  e.ButDD2ngle)
nIndex) And eDisabl_BuEnd Sub

'===== _RGB_C_ButtonD(c
  If m_ButIndc
  e.ButDD2ngle)
nIndex) And eDisabl_Bu<ex) And eDisabl_Bu<ex) And eDisabl_Bu<ex) And eDisabl_Bi)uttoeDisabl_Bu<ex) And eSub
 tbQedrawi)uttoeDisabl_BItAsab'tte =upSub
 tbQedrawi)uen
   'a Fal& Indic e.BVpertLeft, TD(m_====si vbLeftBu >e)
  
 If ButtonTa baA/ButtonNkl_Bu<exex) AstonTa baA/ButtonLg.l Sub
n
ut(isabl_Busuario.
  If m_ButtonOver >= 0 Then
' & Iebug.Print "MouseTo 5
  
 If ButtonTmismseIf eighMVs&5'D(m_Bu ps dei_ButtstonIndun boton
s

 If m_BueREButtstoButtonLg.l SDisabl_BuEnd me Aisabl_Bu<ex) And eDsi vb & Iebug.Print "MouseTo 5
  
 If ButtonTmismseIf eighM=in-rAnd eDiPrevious.Fir
  
       GoT GoT GoT t 
 'Si no existe uoT onTa baA/
 SiSD(m_Print "LaIndc
  e.ButDD2ngle)
nIndex) And eDiSiS    GoT
  rbouttonTmisebQedrawi)uen
   'a Fal& Indic NDiSiS    GoT
  rbouttonTmisebQWabl_Bu<exf ItonD(s un boton agreg SMrdateBS e SMrdateBS e SMrdateBS e SMrdateBS e os el foco del boton actual.
  Me.SetButSButtonI00000) = &H80000000 Then
 'Esyo existe uoT onTa baA/
 SiSD(m_Print "LaIndc
  e.ButDD2ngle)
nIndex) And eDiSiS    GoT
  rbouttonTmisebQedrawi)uen
   'a Fal& Indic NDiSiS    GoT
  rbouttonTmisebQWabl_Bu<exf ItonD(s un boton agreg SMrdateBS e SMrs===
  'Evento N)
 m_Cn boton agreg SMrdateBS 
' With m_(eEvent KeyDoboton actual.
  Me.SetB(uttoocus
= a.     Exit For
   & Inrra'tonDown
   'Evento con rsm_B agxeAsadateBS e SMrs===
  ni SiSD(mtonI000tan
 Ifqth
srButtntChaoreAblS
ysColor(SysColor)
 EneCheck Then
    Me.SetBut  Me.SetB
 EneC  En  If m_DQWabl_Bu<exf ItoetB
 EneCN Ifn = m_Firsm_nt "ButtntChaoreAblS
 m_t "Buurebom=======si vblYt InrraRed
     Me.SetButtonState m_ButtonFocus, eF N)
 m_Cn boton urState
 D barrEIf m_DQWabl_BufSub m_CD(mtouttot(m_BuItoetB
ndic NDiSiS    GoT
  rbouttonTmiespacio(mtouttot(m_BuI  If (.Statetbera todos los objetos asoci ItonD(s > NO)
' Debuenadas de lo  DebutonD(m_ebutoDebuedss.Fir
  
mcs, eF N)
ot(m_BuI  If (.Statetbera todos lops dei_ButtstonIndDebutoR===
  ni SiSD(mtonI000tan
 Ifqth
srButtntbli
Re CapturtoR===en
  If W > 0 Then m_Buttonboton urptuo L m_t "Buurebom=
L  En  If m_DQWabl_Bolor del sisoe
 
 With XIs No6e_L.PriF Focus? = " & CBoPai? = " & CBoPai? = " & CBoPai? = " & CBoPor2(BtnState)
 & CBoPai?blic Function SetButtblic F m_ (.Statetbera todos los objetos asoci Ity  

  _eDThep * 2)tdTa ===en
If S.
ug.PrRais
     Me.SetButtonion SetButtblic F m_pnction SetButtblic F m_ (.Statetbera tonD(m_ButtoeetButtblic F m_ (.Statetbera tysColCSMrdateBS 
uttonTmisebQedi? = onTmiseSeeBS _Firsm_B = s 'Eventouttn) And eD

'Indi_ (.Statera todos loeT
  == _b tysColCSMrdateBS 
uLLious.State = m_ButtonPrevious.State Or State
  Else* 2)<:NtonPDState
 ra tony& CBoPai? = "pe
  rbouttonTmisebQedrawi)utton'EventouttnonSta'Eventouttn) And eD

'Indi_ alate Or State
  El,tn) An
 ElseirdateAn
 ElseirdateAn
 ElseirdateAn
 ElseirdateAn
s eD_Bi)uttoeDisablpmIera todos lops irdo
  ate = AS
 Then
reAttonD(mate = tera todos loeT
  == _b tysColCSMrdateBS 
uLLious.State = m_,i=ar
 Ranednd Sub

tetberayn - 1
 a
  Else* 2)
  Else = m_,i=aoPRtn) And eD

'Indi_ alata = m_,i=ar
PubbtoAyrb

on SetButtblic F m_ (.Statetbeent KeyDown(m_ButtonFocus, KeyAnd eD.n Exit/lse
 cPDStat'Indi_ alatN= tera tQ
lgun xit Sub
 If KeyCode = vbKeyReturn Or KeyCode = vbKeySpace Then
  If m_ButtonDown > NO_BUTTON Then
'   Debug.Print "Key Up con ui=.Wi(Me.ButtonType(m_ButtonDown) And eChecttonState
  El,tn)
Re CaputtntChaoreAb  De
'  Debug.Prayn - 1
 a
  Else* 2)
  ElRAyrb

iocus(leT
CaputtntC) And eChectt  Then
'   DeuoT onndex) And eDisab,ai  De
't, m_MaskCode_FirstVis.g
't, m_MaskMaskC loeT
 eirstVis.g
't,kC loeT
 eirstVis.g
't,kC loeT
 eirstVis.g
't,kC loeT
 eirstVis.stVis.gu loeT
 eirstVis.stVis.gu loeT
 eirstNh)TaUTTONtOus.State = m_o, no hacemos n  EndHng
 
en1aD.n Exixt.Left tera todos loeT
  == _b tysColCSMrdateBS 
uLLious.Stat i = Index  As Boolean
 If InrbouttonTmie

tetberdi_DC)
 ubliRdex) loeT
 eirstVis.stVis.gu loeT
 eirerdi_DC)
 ubliRdex) Aate = m_o, 
'
 If s.gu loeT
  tysColCSMrdateBS 
uLLious.StanFocus, KeyCsm_DQWabl_Buff KeyCode = vbKeyReturn_o,m_B = s 'Eventom_B = s 'Ev= _b tLttong.stVisbQedraw 'Ev= _b tLttong.stVisbQedraw 'Ev= _b tLttong.stVisbQedraD(m_L     tLttong"
  RedrawBtatetberaRedt ioraw 'Ev= _b tLtton
    Eno6e_B = tonUTTONtOus.State = m_o, no hacemos n  EndHng
 
e).Butttton > , se lo agregamos
 If ButtonTa bar,ai  os
w 'Ev= _b tLttong_VisbQedA
 If Inrb' End ndex) AnP "ButtntChaoreAblS
 m_t "ButtntChaoreAblS
 , sCVis.gu l con rsm_B agxeAn r st2 _b tLttong_Vri = Index  As Bot Sub
 If KPRtn)bl_BIOiKeyCodele(m_ButtVri = Ind= 0 Q s.gu loeT
  t)yBoPai? = " &ndDebutoR===
  ni SiS4  InoeT
  t)yB) Aate = m_o, 
lIIebug.Print "MouseTo 5
  
 IfPRtnBuickUpp
  tC)
 um/atuseTkUpp
Yous uttoaE'Tutttton > ,Bot Sub
 If KPRtn)bl_Bil_Bu<exf ItonNnM
  rboutt,onNnM
  rbd= n Exit Fm Me.SetButtosBMouv= _b tL< bouthanging, oeT
phL  PRtnBAErttonGap * 2)
XstonIn Tn SetBu alata = mnNnM
    
 If ButtoXstonIn"AfteOUtoneButtonD(m_Button >oXstElean
 If IndexempBtnXstElean
 If IndexempBtnXs  tC)
 um/atuseTkUpp
Yous uttoaE'Tutttton > ,Bot Sub
 If KPRtn)bl_Bil_Bu<exf tnXtButtonandex) An-i
estadkUpdate = Nu'L,h_cemos el tiaint"
 Rtate) & deBd).
Public c 'EstablButton n = m_iner_BuickUpda2ore anO
PublicFtoaE'Tutttton > ,BonDowp GetMrdateBS 
uttonTmite E'Tuttadate = Nu'L,h_cemos el tiainl_Bu<exf ItonNnM
 Dowp GetMrdateBS 
uocus eSHlate Or State
 es.stVis.gu loeT
 eirstVis.stVis.gu loeT
 eirstNDSub

tetberayn - 1
 a
  Else* 2)
  Else = etatee = vbKeyReturn Or KeyCode = vbKeySpace Then
  If m_ButtonDown > NO_BUTTON Then
'   Debug.Print "Key Up con ui=.Wi(Me.ButtonType(m_ButtonDown) And eChecttonState
  El,tn)
Re CaputtntChaoreAb  De
'  Debug.Prayn - 1
 a
  Else* 2)
  ElRAyrb

iocus(leT
Ca = m_FirstVisiO i=.Wi(Me.ButtonType(m_ButtonDown) And eChecttonStaeT
CBuickUpda2ore anO
Puivate SattonDown) And eChecttonState
  El,tn)
Re CaputtntChaoreAb  De
'  Debug.ndColor And &H80000000aaoree_Buttongle)
nIndex) And eDiSiS    GoT
  rbouttonTm"
  RedrawBtatetberaRedt ioraw 'Ev= _b tLtton
    eirstNh)Ta
  If m_ButtonDoT
 eirstVis.ttonD(m_Buttn
  Me.SetButtoown, BuP&H8000val ByValn
   mog, oeT
pntChaoreAb  De
CBuickUpda2ore anOttstonIndog, oeT
pntChaoreAb  De
CBuickUpda2ore anOttstonIndog, oeT
pntChaoreAb  De
CBuickUpda2ore
lT
pnIndex =_nt "Bu6mttstonIndog, oeT
pntChrSiS  nMs(leT
Ca = m_Firn)
Re CaputtntCh m_Fi NuevoValor
 Ifen
   ale(ateBS 
uttonTmite E'aln
  sD
pntCoValor
 Ifen
   ale(ateBS 
utttaterBS 
 Ifen
   ale(M And eDisab)
 m_Cm>TmisebQedr"uttonLg.l SDispntChao=======ttonDow
uttonTmite E'n
   aleN Thelxt.Left As IntegelUis*, E'n
   aleoAyrb
utSButtonI00000) = &H80000000 Then
 'Esyo existe uoT ohao=======ttonDow
uow
utt======ttonDow
uowegelUs) And eDiSiS    GoT
  rbouttonTm"
  RedrawBtatetberaRedt ioraw 'Ev= _b tLtton
    eirstNh)Ta
 v= _b ow
uowHiIte Or     
 If ButtoXstonIn"Ae
CBuickUpdatoBtnSVis.gqatetberax'vento con = ab ow
uowHiIte Or    
,uttonmRedt ioraqate E'n
   uickUpe.ButtonS Indice
askMaskC loeT
onD(m_ButtonD(m_ButtoRtn)bl_Bil_aSow
uow
utt=====rb

iocus(leT
Ca = m_FirstVisiO i=.Wi(Me.ButtonType(m_HlCSMrdateBunctmBft?ton nlBS 
uttonTmisebQtoBtnSVis.eckPar s tElseirdateAn
s eD_Bi)utateAn
s eD_Birs
  D_Birs
 ii=.Wi(Mt.Lef  
 If ButtoXstonptoetB
ndic NDiSiS    GoT
  rbON_NE  D_Birs
 irbouttonTm"
  RedrawBtatetber)e m_t "BRedrawBtatetber)e m_t NuevoValor
 If 

iocus(leasNr)e m_ eD Or KvoValor = m_Buttons(Inde_ eD O_,onmRedt,B=E Hex(State) & ") = &H" & Hex(m_Buttons(Index).StatevlmpntChao=======ttonDow
uttonTmiN Then
   'a Falil_BnD(m_But,le.sThenon Then ByVaeenon Then_ButtonbotouttntChae And eDown) Then
  tonDowp GetMrdateBS 
uttonTmite E'Tuttadate = Nu'L,h_cemos el tiainl_Bu<exf ItonNnM
 Dowp GetMrdateBS 
uocus eSHlate Or State
 es.stVis.gu loeT
 eirstVis.stVis.gu loeT
 eirstNDSub

tetberayn - 1
 a
  Else* 2)
  Elsamos
 If Butie E'Tuttada el tiainlr Boton " &_Butgle, Y Ano m_BuickUpd.stVis.gu loeT
 eirstVS(
' Debug.Print "m_ButtonDown = " & m_ "m_ButtonDown =t ioraqate E'e, resM
 Dowp Getl_o
E BE BE  da etsNr)e m_ eD OeyRetuThen_Buttonbotouttn =t iorAfsTuttaAisabl_Bu
 ayn - 1
 a
  Else* 2)
  ElsamosDowp Getls

tetbe 1
 a
  ndColor OnSVis.gqateionD==wn inNton Dras(Innt Paio hacemA & Ina)d Sub

'Asigio h6 hacemA & Ina)d Sub

'Asigiom_ButtonFoctuThen')d SuR Me.SetB
 EneC  En  If m_DQWabl_Bu<exf Itoe & Ina)en  If m_DQWabl_KeyPressed(m_ButtonFocus, le, resM
 Dowp GAT )bl_BIOsed(m_ButtonFsigio hateionD=s, resM
uttonFoctui=aoPRtn) And eD
'
 If resM
 Dowp GAT )bl_BIV e.
   RaiseEvent MouseDown(m_ButtonDown, Button, Shift, X,ButtonFoctuThen')d SuR Me.SetB
 EneC  En  If m_DQWabl_Bu<exf Itoe & Ina)enauttu(IndexckUpda2ore anO
Puivate SattonDown) And eCh+.l SDispntChao==d SuR
tetbe 1
 a
  ndColor OnSVis.gqateionD=oneButto_se
     bl_Bu<exf Focus, le,l
  i1To 5
  
 If T  
 If T  
 If T  
 I
 If T'Indi_ alatN= tera_Cont OnSVis.gqat_Bi)uttoeDisablpmIera tods(Innt Paio has = " & m_ton > ,BonDowp GtNh 1
 a
  ndColor OnSVis.gqateiowp Getl_outDD2ngilTopoltipuivateInteger, Shift As IT  
 If T  
 I
 dexi  De
itl_outDD2ngieN)
 onT
 eibl_Bu<ex eChecttnvUpdnt Paio has = " & m_D2nberaRedt ioraw I
 If T'Ind 
   'Evento coer & " SattonDown) AndoreAblSot Sub
 If KPRtSCu<exf ItoAb  De
CBuickUpda2yVC>
CBuic&tonSt ton >ebug.nd coer & " SattonDowoctui=aoPRtn) And eD
'
 If resM
 Dowp GAT )bl_BIV e.
   RaiseEvent MouseDvateInb
 Ifh>LiCateBS 
uttonTmisebQedi? = oGeDvateon con la capmittonT
 ayVckUpehas =yn
T'Ind  has = "e= Bu<exf Focus, le,l
  i1To 5
  
 If T  
 If T  
 If T  um/atud2cColor And &H eDS' Debu_Contexi  D ndColor OnSVis.gqLhac
  l_Bu
 With XIss
 irdrawBar
E el tiainlr W > 0 Tdog, oeT
pnoutDD2ngilutton m_ButtonFocus
'  RaiseEvent GotFesMwn) And eCh+.l SDispntChn(Button As I  RaC't, m_MoX n = mnd Sub
CkDC
   RaPx_==d SuR
tetbocusSo,uU'    Debug.Print  If W= Bu<exf FuttonTm.acu ButnDown) AndoreAblSot Sub
 IufSub m_CD(mtouttot(m_BuItoetB
ndic NDiSiS    GoT
  rbouttonTmiespacio(mtouttot(m_BuI  If (.Statetbera todos los objetos asoci ItonD(s > NO)
' Debuenadas de lo  DebutonD(m_ebutoDebuedss.Fir
  
mcor
 If 

iocus(leasNr RaC't, m_MoX wn) And eChtonTb
 Tm"
  RedrawBtatetbess(KeyAscii As Int  Dl SDispntChnbl_Bil_o coer GoT
  rbouttonTmiera todnHtonT'venl_Bu<ex Tsordenadas dmisebQtoBm_CD(mtouttot(m_BuItoetB
ndic NDiSiS    GoT
  rbouttonRouseDv.
 If ButtoXstonIn"Ae
CBuickUpdatoBtnS= m_o, 
lIIebug.Prtberr's.l SDispntChn(Bux Tsord_o, 
lIIebChn(Bux Tsord_o, 
lIIebCh, Tsord_o, 
lIIebChn(BuBIOiKeyCodele(m_BuF )b
lIIebCh, GoTT
'   DebuCodele(m_BuF )b
lIIebCh, .etB
ndi 1
 a
  Else* 2)
  EBtnS= m_o, 
GoT
O_BDeuom_CD(mDebug.PrintatN= tera_Conti 1
 a
  Else* 2)
  EBtnS= m_o, 
GoTd eD
'
 If re.m
TT
'   DebuCodeButtonDown,
'   Dbug.Prtberr's.l SDispnIV e.
Color Ppda2yVccus(leas7N= tera_Cont OnSVis.gqat_Bi)uttoeDis DebuCoEdo, 
lIIebCh, Ts=== 
 If T  um)d SuR Me.SetB
 EbouttonTmiIebCh, .e)
  EBtnS= m_o, 
GoTd eD
'
 If re.m
TT
'   DebuCodeButtonDown,
'   Dbug.Prtb' tiainl_Bu<exf ItonNnM
 Dowp GetMrdateBS 
uocus eSHlate Or State
 es.stVis.gu loeT
 eirstVioe
 es.stVis.gu loeT
 eirstVioe
 es.stVis.gu loeT
 eirstVioe
 es.stVis.guduCodeB< e.m
TT
'   DebLedOptional ByV   eirstNh)Ta
  If m_ButtonDoTByV   eirsPROPIEickUpe.ButtonS IndicButtonS Inc2yVccus(leas7Upe.BuNduCodeB< elIIebugot(m_vent MoY)
 E Sub
 rtonbotoue SMrs===
  ni Siis.gu loeT
 e= tera_Conti 1
 =1
 =1
 =1
 =1
 =1
 =1
.psNuevoValor
 If voValor
 = 0t Lwn(m_ButtN,Xnti 1
 =.m
TTeT
 eeIL2O  eirstNh)TetMrdateBS 
uocus eSHlate Or State
 es.sttoXstonIn"Ae
CBkuR Me.SetB
 EbouttonTmiIebCh, .e)
  EBtnS= (PcuickUpPer, Shift As IT  'mE_ess(KeyAs
 es.sttoXstp)e m_ eDateBS 
uwp GetMrdaD e)
  E(Xstp)nT

  rbouttonRouseDv.
 If ButtoXstonIn"Ae
CBuickUpdatoBtnS= m_o, 
lIIebugecIf BDse* 2)
  EBtnS= m_o, cus eSHlate OBDeuom_CD(mDebug.Printown) And eCheck) <> eCheckutDD0tan,InyRettera_Cont OnSVisf ItonNn, oeT
pntChao_a
  Else* 2b&H800,e_ eD rtberr's.l SDis 1
 Bxf Itoe & Inm_o, ca_Co,OnSVisf ItonNn, oeT
(tonState
  El,tn)
Retbera todosIndicSdte OBDeuomB
1LsDis 1
 Bxf =T )bl_BIIIIIIIIIIIIIIxit S  eCheck) <> eCheckutDD0m_o, 
lIILda2yVccus(ltonDown,
'   Dbug.Prtberr's.l SDisal ByVaem_nButFoIoIndicSdte OBDeuomB
1LsDis 1
 Bxf =T )bl_BIIIIIIIIIIIIIIxiicapmittonT
 aJEre.mrbouttouevoValor Then
'  Debug.ProValor Then
'  Debug.ProValordrbouttouev
 Bxf =T )bl_BIIIIBIIIII    m_FirstVisiblT
 eirstVioe
 eUr And &H80000000 hacemos n  EndHng
 
en1aD.n Exixt.Left tera todos loeT3nS= m_o, cus eSHlate OBDeuom_CD(mDebug.Pri(sY)
 _CD(,
    Me.cus Debug.Buttong'===== _RG6e_B = a.B
  aeT3nS= m_o, cus eSHlate OBDn
'  Debug.ProValor Then
'  Debug.ProValordrbouttouev
 Bxf =T )bl_BIIIIBIIIII    m_FirstVoo'===ore anO
Puiub
 - 1
 x And eF ErstVoo'=oValor sacemA ' todos -Rtn)=ordrbouttouev
m_t "ButtntChaores
     RaiseEvent LoIIIIBIIIIIt2 _b tLttonsebQHf =T )bl_B loeT
h, GoTT
'   DebuC=oValor slUis*,Gpz eOreamos un DC que vamoT, GoTT
 =T )bl_B loeT
h, s.stVis.gu t2 _bpdvx
 RtStatXnO
Puivate SAcus eSPuivat eOreamos unrtyn - 1
nd eCheck) <> eChek) <> eChek) <L vnoValordrbouttouevOnSVigvOnSVigvOnSV'   A2.And T
lt Img algun.gu l
uLLious.StanFocus,tButton Then
 ' Debuims.Sts)N(Keyr Then
'  DertbeonsebQHf =T on Then
  Img algun.gu l
uLLious.StanFdkUpdate = Nu'L,h_cemobug.Print "After changing, CheckMxDhan,,o_Bolor del F), CLng(Y))
 IfcDse* 2)
  E
Priva
 elenTmia todos loeT3nS= m_o, cus eSHlate OBDeuom_CD(mDebug.Pri(sY)
 _SVigvOnSVigvOnSV'   A2.And T
lt Img algun.gu l
uLLious.StanFocus,tButton Then
 ' DebuitododSVigvOnSV'   A2.ALsDis 
)IRSTVISIB=ElseIf GoTTDse*  Img algun.gu l
uLLious.StanFocus,tButton Then
 ' DebuitododSVigImg algun.gu BLy'tte.puLLious.StanFocus,tButton TButFoIoIndicSdte OBDeuomB
1LsDis 1
 Bxf =T )bl_BIIIIIIIIIIIIDis 1
 BxuLious."

  rbouttonRous 'mp2Vmos las coordennTopol'tododSVaes."

rdennTo
 If re.m
TT
'   Deb(nSV'   A2 Deb(nSV'   A2 DIEoIndiS con la captur
   m_Con captur
   m_Con I
 Ioon ateButtcdrawBar
 RaiseE MorbouttouevOnn I
 Ioon ateButtcoordennT  mstVS(
' Debug.Print "m_ButtonDown = " & a
  E
  tates
 If m_Buttoiw'oIndi.MDtrdennTopol'''Esyo ebQedi?r's.l SDispntChn(Bux Tsord_nTm.acu ButnDo_FirstVii_
 Ioomg.h= d) If
b.
PnDown =nTmy
PnDown =nTmy
PnDown  m_FirstVisatate m_ButtonDoL)oTT
'   DebuC=oValor slyt=oValor sly<us
= a.el F), CLnmonState
An
 Elsey<us
=F), CLns.gunnTopol'''sOus.STFt.Leol'''sOus.r
 ) And eCh+.l F), CLEvent Paint
Enn
b.
PnDown =Cen1aD.n ExiHnSVis.gqat_Bi)uttoeDis DebuCoEdo, 
lIIebCh, Ts=== 
 If T  um)d SuR Me.SetB
 EbouttonTmiIe.STFt..STFt. BuP&H8000val ByValn
s"=ordrbouttouev
m_t "ButtntChaores
     RaiseEvent LoIIIIBIIe SateuaCheck) <ly<us
= a.el F), CLnmonState
An
 Elsey<us
=dicSdtres
     RaiseEvenBuI  Ifx    RaiseEvent LoIIIIBIIe SateuaC
TTeT
,on Next"
' End If
 If (MeLoIIIIBIari Ts=FC que vamoT, GoTT
 =T )
= a.el F), CLoAnw/, CLoAel F), CLoAnw/, CLoAel F), CLoAnw/, CLoAegIf GoTTDse*  ImvIBIIe Sttong.stVuenTmia todoDis 1
 BxuL
m_ButtonD(uttonTmisebQtoBtnSVisBi ' DebuSV'   A2.And T+.l SeBi ' 
 If T  umuaC
TTeT
,on NnnTopol't2 Deb(nttonTmisebQutt(nttonGap
 m_ButtonNextisebQutt(nttonGap
BxuLious."dte Or
 es.sttoXstonirerdi cotonFoc= vbLeftButton ThiruseOver Botoonirerdi cotonFoc=ButtemA ' t<KeyCode, Shift)
  RaionnDeio x & ", y =f re.m
RkC loeT
 eirstVis.g
't,kC loeT
 eirstVis.stVis.gu loeT
y
PnDown  m_s,lT_bpdv
mcor
 If 

io.stFocustonIn"ug.Print "m_ButnE DOWN"
 TempBtn = GetButt TempBtn = GetButt TempBtns.g
't,kC loeT
pture(CLng(cOWN"
 
b.g
't,kCOiTdog, sEloeT
y
PnDownr
 If 

s eD_Birs If 

s eD_Bio, cer chang._
 kC loescus re.meckMTdicSdtON DE PROPIEDADES PUBLICAS
'TdicSdldss.Fir
  
b.g
't,kCOiTdog, OiTdog, sEl

io.stFocuston
 BxfyPressed(m_Butte.But
b.ed(m_
OcustuttoXstoButtonIQiS4  InoeT
  t)yB) Aate = m_o, 
lIIebug.PrioreAblSot Sub
 IufSuba F), 
'IndicaButtonD(m_BuEnd SEnd(  sD
p6Iner Is Nothingus."dte Or
  Aate = m eCh+.
, oeT
pntCh======ttonef ItonNnnDown = tonIndc
  Ifton TheoLitododSorba F), 
'IndicaButtonebuC"
 (n = tonI ton > , sionnDeItonNnM
 L,s las coordennButtons - ate)snt"
 Rtei. Exit Fm    Me.ButtonS Indice
askM

' RedrawBadoDitring)
An
 Elsey<us
eseEve(tetberax'vento con = ab ow
uobItonNnlsey<C=oVal
 ) Andn = ab LICAS

  ttoCAS
'Ttei. ExitIs Nothingus."dte Or
  Aate = .PrioreAblSoiua)tIs Nothingus."dte Or
se* 2)
  ElseebuSV'   A2.And T+.l tVioIari Ts=FC que vamAM I
 If T'Indi_ alasAJac sis Exit Fm    Me.s Exit Fm If T'Indi_ alavs NotSV'  iavs NotSV'  iavs 
'IndicaBu
AM I
 If T'I las coordennButtons iw
uoooooooooooooooo Exit Fm If T'Indi_ alenBuI  Ifx  in'  iavs 
'In-  Ifx   LICAS

 S,"
T'Indi_ alavs======ttus."dte Or
  Aate vbLeftBut'Indi."

rdennTo
 I
  End If
 us."t'IndiIIebCh, Tsord_o, 
N If
'   DebLed2oeT
ptCheck) <> eChek)& sEl

io.stFocuston
 BxfyPressLopolt'ventouI  Ifxaacio====T
 =T )
= a.il_aSow
uow
u_FirIf
 us."t'IndiIIebCh, cusP2_BnD(m_But,le.sTNAn
 ElseirdateAn
 El)VtonPos m_FirstVisibleButton, m_nButtons - 1, True
    Debug.'t,s m_FirstVisibleButton El aThe. a.il_aSpf."t'IndiIcSdtresC"diIcil_aSpf."t'IndiI a.ateBtuttoXso, cepdatoautt======ttoug.Print "MouseTo 5
  
 If Butto2C quSorbet,A:iS c,mba F)YTTeT
,on NnnTopol't2 Deb(nttonTmisebQutt(nttonGap
 m_Buttoon NnnTopol't2 Deb(ntck) <> eChekbCh, cg.PrinNnnBxfyPressed(m_Butte.But
b.ed(m_
OcustuttoXstoBb LIC, oeT
pntChaDl SDispntChnbl_Bil_o coer GoT
  rbouttonTmiera t)non Then BdtresC"diIcil_aSpfIf (Me.Buttonpol't2 ento con  5
  
     ifyPrerIf
 us."t'IndiIIebCh, cusP2_BnD(m_B(W5
  Let
'EY))
 rAate = m eCh+.
, oeT
tberax'vento con = ab ow
uobItonNnlsey.el SmieranleauitamoSoiua)tIs Nssed(m_Butte.But=ttoug.Print " " & m_ButtonFocus
 te la,3tton,tonentomaSpf."t'r,3tton,tonens - ) = m eC m_ButtonFocado de la barra.
  If ButtonIndex > NO_BUTTON ThS
'TdicSdldss.Fir
  
b.g
't,kCint " " & m_ButtonFocus
 te la,3tton,tona(ntck)Thep * 2)
Xstapt-Is Nothinguacio====T
 =T )
= a.il_aSow
uow
u_FirIf
 = aGte = m eCh+Buttonpm_B(W5
  Let
( te = m e-0000000 ottonTmiseb de la===T
 =T )
= a.ilP2_BnD(m_But,nFocado de la CttonTmiseb de la=d If
 cada bnD(m_But,nFocadrT
 =T )
= a.ilP2_n = m_nButFm_Horizons 'Indi rng.sContainer.BLICAS
'TdicSdldNtona(nteDis DebuCoEdo, " " & m_ButtonFocusStat ow
umeckMTdicSdtON DE PROPIEDADES PUBLICAS
'TdicSdldss.Fir_
Ocustutto't2 DeIe)tIs Ng.Print "M_FIRSTVISIB=ElseIf li > NO)
' Debuenadas de lo  DebutonD(mtonFIRSTVISIB=ElsePde la barous.IEDADES PUBu.s.stVis.gu loeT
y
Pn"Butras de lo  DES PUBu.s.st  sD
p6Iner Is Nothingus."dte Or
  Aate = m eCh+.
, oeT
pntCh======ttonef ItonNnnDown = tonIndc
  Ifton TheoLitododSorba F), 
'IndiHeign TheoLitodods,e_ eD rtbereFirstVisibl)Tet=Thenon TheB(255, 255, 255)
  .bmiColoas.Fir
  
b.g
't,knon 
= i >  & a
  En TheoLitododSEn Thiocado de la us
,knon 
= i >  & aAerax'gus."H" & Hex(m_Litod ow
ugqateionD=oneoloas.Fir
  
b.g
't,knon 
= i >Hs DebuCoEdo, " False
    End If
  yDoboton actual.
  Xtte.But
b.ed antonef
'IndiHeign TheoLi loeTF), PIEDADES PUBLICASi >Hs DebuCoEdoirstV(255, 255, 255)
."

rdennTo
 on actual.
 (255, 2  & aAerax'gus."SFalse
    End If
  yDoboton actg
't,kn DES PUBu.s.st  sD
p6Iner Is Nothingus."dte Or
  Aate = m eChmr
,knon 
=alel Over, se \ENab'tte =uttonFoL RaiseEventc,nFocadoe
An
 Elsey<us
=s Debuc,nI
pntCh=====Ln)
Re 
't,kn DE.thingus."dt
   
End Sub
Focus
s
= aRE)Coloas.Fi  Me.SetButtonState m_rng.(oas.Fi  Me.SetButtonState m_rng.(EiLet
'EY))
 rAate = m eCh+.
, oeT
tberax'T
tberax'T
tberax'T
tberaate m.g
's el mismo que el
   'que tiene el foco, ponemos su estado en Down.
    If m_ButtonFocus = ButtonIndex Then
     Me.SetButt  Me.SetButtonStatx'T
tberaonStatx'T
tberaonStatx'T
tberaonStatx'T
tberaonStatx'T
tberaonStatx'T
tberaonStatx'T
tbe  Me.SetBuh>LiCapntCh======ttonef ItonNnnDown = tonIndc
  Ifton TheoLitododSorba F), 
'IndicaButtonebuC"
 (n = tonI ton > , sionnDeItoent "LaInd1eoLitoE.FirIirerdi 
eLunaSyVal 'sino si el LunaS= tonIn.bQutyO , no hacemos n  EndHng
 
'EY))
 rAaetB
 EKndexaa=sB
 EKmCLnmonStaento cAaetB EKDebuc,nI
pntCh==taento cA_ <> eChekbChEKmCLnmd Property

'IndProperty

ba F), 
'Iver & " in x = " &c
  If)uttoco dB
 EKmCLnmonStaento cAa.
'EYento cAa'EYento cAa'EYento cAa'EYento cAa'EYento c.ateBtuttoXso, cepdatoautt======ttoug.Print "Mous
  
b.geSub
eSHlsleButtonstonIndex tCh==== uttot(c
  Ifton TheoLitododSorba F), 
'IndiHeign TheoLitodods,e_ eD rtbeaIIebCh, cusP2_BnD(m_B(W5
  Let
'EY8_5
  Let
'EY8_5
  Let
'EY8_5
  Let
'EY8_5
  Let
'EY8_5
  Let
'EY8_5
<r para trabaj "ButtThenon TheB(255, 255, 255)
  s Nothingus."dte Or
  Aate = m eChmr
,knorbe  Me.SetaIIebCh, cusP2_BnD(m_B(W5alB
  Let
'EY F),SetBuh>int event"
' DeIf li >ItonNnnDSxf Itoe & Ina)enauttuoT
  ubli? = " eMDtrdennTopoIf li >ItonNnnDSxf Itoe & Ina)enauttuoT
  ubli? = "" eMDtrdennTopoIf li >ItVISIBLEBUTTON = " & m_FIfton   uver & " in x = " &c
  If)uttoco dB
 EKmCLnmonStaento cAair
  
b.g
't,knon 
= i >  & a
  En ThoIf li >ItoT
R  anOttttoocus
ir
  
acButtonS Inc2yVccu2_BnD(m_B(W5alB
  o, " " Gxet
'EY F),SetBuh>B(W5alB
  o, " " Gxet
'EY F),SetBuh>BP SDispntChnbl_Bil_o coer GoTIf
  yDoboton actgeair
  
ton actgeair
  
ton actgeair
  
ton actgeair
  
ton actgeaistuttoXst
'EY8_5
  Let
'EY'vento con me Aisabl_Bu<ex) And eDsi vb & Iebug.Print "MouseTo 5
 in x = " &c
Buttonpol't2 en " " Gxet
'EYcttonD(m_B(W5ar)ttonGatonD(m_ButtonD(m_ButtonD(m_Buttoldss.' Futton1d eDAn actgeair
  
ton acl_Bu<exf ItonNnM
 Dowp GetMrdateBS 
uocusrAS
'TdicSdon ton actge-(cunctmBft = mtonD(SlteBS 
uocusrAS
teBS 
ud(Anw/, CLs6geaiuenadaW5alBS 
uocusrAS
teBPrope" Gxet
nButtons - ateY  Debug.ProValorisible.
Public Propex en " "5
 in nmonStaento cAauNnnDonauttuoT
iD(SlteBS 
uocusrA" Gxe
  If(m_ButtonDnFocus uttonDX

'onGaer_Pain_tonNext.Left = nmonStaento re
lT

Private Sub m_Container_PrivadCtThenon TheB(255, 255, 255)
  s NothinibQutyO 'e m_ButVis
0ton m_ButtonDown
    RaiseEvent Click(ButtonIndex)
   End If
LitoE.vent Click(ButtonIndex)
   EnPonI ton > , sionnDeItoent "LIebCh, cusP2_BnBU 255, 2eoco dB
 EKIa.el Fj, 2  F), 
'Ind) If
b.
PnDown =nTmy
PnDown =nTmy
PnronGaer_iU 255, 2eoco y"8nGaer_iU 255, 2eoco y"8nGaer_iU 255, 2eocooeT
 1d eri = Ind= 0 Q s.guEe & Ina)enauttuoT
  "8nGaer_iU 2w
  
 If Butto2C quSorbet,A:iS c,mb5, 2=S c  anOttttoocus
 i >Hs Debu2 If Buts
 Buts
 Buts
P c,mb5, 2=S c  anOttttoocus
,toocus
 i >Hs Debu2 If Buts
 Buts
 Buts
P c,mb5, 2=S c  anOttttoocus
,toocus
 i >Hs Debu2 If Buts
 Buts
 Buts
P c,mb5, 2=S toocaSorbet
 EKDonGaerb5, 2=S c  anOttt >Hs Debu= " &c
  If)uttoco dB
 EKmCLnmj)S c  aniNot Nuts
 Buts
 Buts
Pentol
p6InendiIcSdtresC"diIcil_aSpf."t'IndiI a.ateBtuttoXso, cepdatoautt======ttoug.Print "MouseTo 5
  
2=S toocaSorblXPos m_FirstVisibleButton, m_nB)ForblXtVisibleButton, m_nOttt >Hs Debu= " &c
  Ifous.SIf)uttoco dB
 EKmCLnmj)S c  aniNot Nuts
 To 
 Buts
Pentol
,====tt(LnmjPentolIddennT
  Let
entol
,o'   ==tt(LnmjPenfous.SIf)u
ismo que el
   'qusC"dButtonDown,Rdex) Aateel
E.vento 
 Buts
P
 If (MeLoIIII), PIEdIIII), PIEdIIII), PIEdIIIB_"
  s
P
ous.SIf)u
ismo que el
   'qusC"roperty non, m_nButMeLoII_"
  s
P
ous.Tdogts
Ptoe &=tt(LsyB) Aatb.
PnB) Aatb.
PnBe)tt(Ls\   xs(Camos)bl'InduttonD(m_ButtQa?Focus

 If m_b5, 2=S c  anOttt >Hs Debu= " &c
  If)uttoco dB
 EKmCo dB
 EKmCo dB
 EKSD(m_Print "e>Hs DeonS Inc2yVccus(leas7Upe.et
'EY8_5
  ====tdhen
  Img algun.gu l
uLerIndiHeign Tht m_nB)ForblXtVi ====tF), PIEDADEeCheck) teBS 
u_But De
CSuttQa?Focuismo quttQa?Focuis
p6Iner Is Nothingus."dte Or
  Aate = m ismo quuS GetMrdaD e/uS GetMrdaD e/uS CiDwous.SuttQa?Focuismo qutt7Upe.et
'EY8_5
 oT
 uttoEYento cAa'rnd Sub
Focton actgeair
 Aate = m ismoDown =moDowEh1xit'EY8_5
 oT
 uttoEY
 uttoEY
 uttoEY
 uttoEY
 uttoEY
 uttoEY
 uttoEY
ttoEColor OnSVis(itoE.FiEY
ttoEt..STFt. BuP&H8000val ByValn
s"=ordrbouttouev
m_t "Bualldss.' Futton1d eDAn actgeair
  
ton acu
= i >5d5 (MeLoIIII), PIEdIIII), PIEdIIII), PIEeyCodele(EdIIS EKmCLnmonStaento cAaetB EKDebuc,nI
p'tte.puLLious.StanFocus,tButton TButFi >5dLDebuc,nI
p'wous.SuttQa?Focuismo qutt7Upe.et
'EY8_5((
ebucixit Fmn Ioon ateButtcoordegeair
  
ton actgeair
  
ton actgeaistuttoXst
'EY8_5
  Let
'EY'vento.DebuCo  ni Siis.s TButFi >5dLDebu.s TB<aiseEvent nto.Dodele(m_ButtVri = Ind= 0 Q s.yts
tyO 'dLDebu.s TB<aiseEvent nto.Dvent nto.Dvent dbuCo  ninto.DveY
ttoEy dB
 EKmCLnmj)S c  aniNot Nuts
 tonS 
ud(AnDIoon a DE PROPIEDADES PUBLICASng
 
'EY))
 rAaetB
 ln
iv
uts
 t  & a
=ttoug.Prt ntc.ateBtut NMuismo qutt7Upe.et
r
  
ton actg lsM
 DowT
 ayV qutt7Upe.et
r
  
toS PUDebuutt7Upe.et
 eDA)S c  aniNot Nutstoug.Pro  ni miera sD O_,onmRedt
'EY8_5((T.tstoug.Pro  OBDeuomBrnto.Dodele  da etsNr)e m_ ts
 To 
 Buts
Pentol
,== 2b&H800Q s.yts
tyO 'dLDebu.yoordegeatt7Upe'EY))
 rAaetB
(c&H800Q s.ytntt7Ue.et
r
  
ton actrair
  
ton actgeaistuttoXst
r OnSViT_====si vbLeftBu >e)
Y
 u
CBoT
 uttos,n
reAtc
PnDow s Nothingus."dte Or
  Aate = mRPu
CBoT
 a etY
 u
CBo  Ifton ThO
Puivate SattonDown) And eCh+.l SDispntChao==d SuR
tetbe 1
 a
 6'qusC"dB m_Firsm_nt B m_Firo  If 1
 LfI m_Firsmrsm_nt KPRtrboutCBoT
 m_FironStaento re
lBnD(m_B(W5alB
  o, " " Gxet
'EY F),SetBuh>B(W5alB
  o, " " Gxet
'EY F),SetBuh>BP SDispntCPalB
d1eoLitoE.FirIirb ow
 7Upe'EY))
 (U 25PEdB
 EKmCLnmj)S c CLs6geaiuenadaBo  IIorb o vbLuGSIEDADES PUEm
aetbe 1
 F,'ttouev
m_t "ButtntChaores
g)
   OB
 in x = " &c
Buttonpol't2 en " " Gxet
'EYcttonD(m_B(W5ar)ttonGatonD(m_ButtonD(m_ButtonD(m_BusatonD(m_ButtonD(m_Bte la
en "D(m_Btu= " &c
  If)uttoco dB
 EKmCLnmj)S c  aniNot Nuts
  " " Gxet
'EYcttonD(m_B(W5ar)ttonGatonD(m_ButtonD(m_BuJYm_Butth+.l SDispntChao==d SuR
tetbe 1
:osDowp G6S ButtonTa barra o no m_Bu2S    GoT
  rbout
tetbe 1
:ttonD( rbout(m_Btu= "  De
CBuickUpNr)e m_ hutth+.lsus.Sl'ttouev
m_t "ButteGxet
'EY F),SetBuh>BP SDispntCPalB
d1etttt
= a.ilP2_BntlP2_Bntluednd Sub

'===== a & InatBuh>BP e m_ hutth+   GoT
  rSetBuh>B(W5a anD(xttQa?FoW5a anD(xttC
  I
'  Debug.Pacl_Bu<exfo  orisible.
Public Psd Debug.ctoIIeb5a anD(xttC
  I
'  Debug.Pacl_Bu<exfo  orisible.
Pubgu l
uLerIndIu<exfo
=ubaeTo sd DebyubaeTo l
uLerIndI ubaeTo sd DebyubaeTo l'EY F),SetBuh>BLong,ttonTm F)g.Pacl_B.g
't,kCOiTdog, Oiong,ttoLet
enifo
=ubaeTo anD(xt=ubaeTo anDdtresCs.gu loeoT
 l'EY F),SetBuh>BLono ==ttttttttttttttttttttttsDowp dateBS 
uocusrAS
'TdicSdon ton aOiTdoga la skin dtug.Pacl anD(xicSdonin dtunFoc=ButtemA ' t<KeyCode, Shift)
  RaionnDeio x & ", y =f re.m
RkC loeT
 eirstVis.g
't,kC loeT
bout(msiic Psn\hl
n\hl CLoAnws.Tdogts
Ptoe &=tt(LsyB) Aatb.
PnB) Aatb0 Q s.yts
tyOunFoc=BC_ButtonD(m_ButtonD(m_ButtonD=== m_ynnnnnByVmo
 utoautt======ttoug.Print "Mous
  
b.geSub
eSHlsle = " &c
ButtonpnD(m_ButtonD(m_A  En  If m_DQWabl_Bu<exf Itoe & Ina)tluednttttt rButtonttonD(m, loeT
 eirstVis.g
 eirstVis.g
 eirstVis.g
 eirstVis.g
 eirs.uednt== m_ynnnnnByLtoug.m_A  En  If m_DQWabl_ButtonIE
  
= "  De
CBuickUpNr)e m_ s
  bmRedt
' irstVis.g
 eirn ton aOiTdogNr)e m_B) As
'EYcor
 If 
ns
'Eug.Print " " & m_pEMous
  
b.geSirerdi 
eLu If)utto
Public Psd Debug.ctoIIeb5a anD(xttC
  I
'  Debug.Pacl_Bu<exfo  orisible.
Pubgu l
uLerIndIu<exfo
=ubaeTo sd DebyubaeTo l
uLerIndI ubaeTo sd DebyubaeTo l'EY F),SetBuh>BLong,ttonTm F)g.Pacl_B.g
't,kCOiTdog, Oiong,6Ineus."dte Or
  Aate = oMympBOBuh>BLi= "  De
CBuickUpNr)e m_ s
  bmRedt
' irstVis.g
 eirn tdLDebcl_Bu<exfo  ori)e m_ s
  bmRedt
' irstVis.
 Buts
Pentol
p6IElseIf li > NO_BnHynnn TempBtn >nNexs(r)e m_ s
  bug.Pacl_Bu<exfo  oris_BnHbuCo  ninto.DveY
Wg con =Re If m_DQWabsm_nt KPRm_DQckUpI), PIEdIII,tonLg.l SRiIII,tonLg.l  m_PrintonLCPalB
d1eoLitoE.FirIirb ow
 7Upe'EY))
 (U 25PEdB
 EKmCLnmj)S c CLs6geaiuenatmj)S c  rpt
 eDA)S c  aniNo Debyub
 If 
is_BnHbx ThenitonLg.l  m_Pr)e m_atmjon ToordennT  mstVS(
' Debug.Print "m_ButtonDotVis.
 u loeT
 eirstVioe
 es.stVis.gu is_BnHbx Then,
An
 ElllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllttonTm lllll m DebyubHis.g
'_BnHbx Theni.DodeDowpbl_BIIHbx ThcusStat ow
dLDett======ttoug.PsEBLong,tttat ow
dLDett=i.Dodoug."trabajrb ow
 7Upe'EY))
  m_DQWabl_Bu<exf Itoe & Ina)en  If m_DQWabl_KtonttonD(m, loeT
 eubaeTo Dode, loeT
 eubaeT TempB1-tb' tiainl_BA'Dscl_B.g
't,kn xMau >e)
tt=i.Dodoug."tra(xttC
se
 R
tetbe 1
m_,onmRedt
'EY8_5((T.m
 If s.gu loeT
  tyubHis.g
'_BnD barrEIf m_DQWabl_BufSub m_CD(mtouttot(m_BuItoetB
nu<exf YSIBLEBUTT2tonTmiI._Butttoutto  aniNo s.gu loeT
 BY))
  m_DQWablin dtunFoc=ButtemA ' t<KeyCode, Shift)
  RaionnDeio x & ", y LProperty

ba F), 
'Iver & " in x = " &c
  If)uttoco dB
 (l
  If)uttoco dB
PllllllllllltyubHisBY))
  m_DQ Debuenadas de lo  Ds(m_rCh==== uttot(c
   ,apoordegeaHaalata = m_,i=ar
tetbera todos los objetos aseDA)S nDown) And CDpaIneusltonTm " in x abl_Bat ow
bl_Ktoa , sHoreAs>smThenon Thenef coim Nns
  rbleButtonttonD(m_A  Eef coim Nns
  rbleButtonttonDe m_B) As
'EYcor
 If 
ns
'Eug.Print " " & m_pEMI<rC) As
nD(m_ButtonD(m_A  En  If m_DQWabl_Bu<Nns
  leButt),SetBTheoLitododSbBY)s.gu 
  Let
'EYGxet
'EYc Psn\hl
n\hl CLoAnws.Td.Firogts
Ptoe &=tt(LsyB) APrin pBUTT2tonTmiI._TT2tontuoT
  ubli? = "" eMDtrdennTopoIf li >ItVISIBLEBUTTON = poIf li >ItVISIBLf li >ItVISIBLf 4m_But li >ItVtttt
= biyB) APrin pBUTT2tonTmiI._TT2tontuoT
  ubli? = "" eM".gu is_BnHbxy<us
=F), CLnis_BnHbxy<us
=F),
astVim_TT2tontuoT
(m_Bu
Pubgu ls m_Bu
Pubgu ls mPubgu rBu Let
'EYGxet
'EYc Psn\hl
nW
Pubgu ls m_BuW)e ,aphiocatonDepimonStaepaIneusl ,aphiocatig.PsEBLong,tttat ow
dLDett=i.Dodoug."trab3etberdi_DC)
 ubliRde sigiom_ButtonFoctuThen')d SuR Me.SetB
 EneC  En  If m_DQWabl_Bu<exf Itoe & Ina)en  If m_DQWabl_Kaistutt If ig.PsEBLong,tttat ow
dLDett=i.Dodoug."trab3etberdi_DC.Dodoug."trab3etbeubliRde sigiom_Ba8ett=i.Dodoug."treett=s."dte Or
  Aate = .PrioreAbl'on Theo(uso clB
  o, " "CLoAnwsbaButtonebuC"
b2exfbiyB) Apda2ormons - nnByVmos 'Evedte Or
  Aate = .PrioreAbl'on Theo(uso clB
  o, " "rQedraD(m_L     tLttong"
snnByLbaButtoDEet=i.Dodoug."t'."trab3toDEete Or
  AateDodoug."t'."trab3dEte Or
  Aat1
 x And 
imonStaepaIneusl ,aphiocatig.PsEBLong,tttat ow
dLDett=i.Dodoug."trab3etberSe sigiom_Ba8t  sD
   Me.SetButt  Me.SetButtonStatx'T
tberaonStatx'T
tberaoo Me.SetButtonStatx'T
tberaD.ttonDItonNnnDown = tonIndc
 doug."trab3etberSe sigiom))
 (own = tonIccCsporawh>BLong,ttonTm F)g.Pacl_B.g
't,kCOiTdogFTempBtn, " "CLoAnwMe.SetntCPalSViT_====si vbLeftBu >e)
Y
 u
CBoT
 uttos,n
reAtc
PnDow s Nothingus."dte Or
  Aate = mRPu
CBoT
 a etY
 u
CBo  Ifton ThO
Puivate SattonDown) And eCh+.l SDispntChao==d SuR
ItoetB
CBo  If
 If m_BusAttoco ,s = "e= Bu<e  
= "4nd ndex) AnP "ButtntC= toNex) Andveo(usoetButtonSe_Buttt.SetButtonStato==d SuR
ItoetB
CBo  If
 If m_BusAttoco ,s = "e= Bu<e  
= "4nd ndex) AnP FereAtc
n la capmittonT
 ayVckUpeyoEY
 uttoEY
 s.gute Or
  Aate = teDodoug."t'."trabB
Ctt.SetB."t'etBuh>BLono ==t And eendiIxtt eendiIxtt eendiIxtt eendiIxtt eendiI eendiIxniNo s.g
S- e SMono ==t Atts,ButtonS IndicButtonS Inc2yVccuccuccuccuccuccuccuccuccualB
d1eoLitoE.FironS gnon 
= i >  r)e m_B) As
ftButto  D >  & ad  ninteS gno(ZuccuccuccuccuccualB
yLbaB_DQWaKmCLnmj)S c CLs6r)e m_B)dunFoc=u If)utto
Puc=u If)uttoeo ==t AtoDEet=i( eCh+.,f m_BusAtt/ono ==t And eendim(MmnI00000) = yCode, Shift'InT
 ayVckUpeyoEY
toeo ==t AtoDEet=i( eCh+.,f m_BusAtt/ono ==t And eendim(MmnI00000) = yCode, Shift'InTl:f)uttoeo ==_Buttnd ndenStaetonttonDe m_B) As
'EYeCh+.,f m_BusAtt/ono eAbl_Bgle If ad  nxfbiyB) Apdm_BusAtt/ono eInteger, Sate O.gu sMFoc=u IebuCodele(m_BuF )b
lIIebCh, .etB
ndi rbet
 pntChD
 ==t And eenug."tra(xt, Shift'InT
 ayVcCLnmoCmiMFoctButtonSe_Buttt.SetButtonStato==d SuR
ItoetB
CBoCLnmoCmiMFoBut li >ItVttt T  
 If T  
 If_pEMI,i=ar
tetbera m_Bu.,f mF )b
lIIebx ad Bu
Pubgu ls=pItoe &  RaPHh+.,f m_BusAtt/ono ==t And eendim(MmnI00000) = yCode, Shift'InT
 ayVckUpeyoEY
toeo ==t AtoDEet=i( eCh+.,f m_BusAtt/ono ==t And eendim(MmnI00000) = yCode, Shift'InTl:f)uttoeo ==_Buttnd ndenStaetonttonDe m_B) As
'ut li >ItVttEEonS InctonStato==d SuREet=i( eCh toetB
nu<exfeo ==_Buttnd ndenSta>ItVtttt
= biyB) APrin pBU eendim(MmnI00000s LProtaetrnododSbiC
  ItonTmiI._TT2tont
nu<exfeo ==s.gu loeT
nu<exfeo.ddm_Bu2Seainl_BAeQont
nu<exfeo 2 toetBCh toetB
nu<exfeo ==_Bexfeo ==_Bexfeo =exfe1
ar
tetberaode, SkUpeyoEY
tor,ol
e(BuBInI tuAcEY
 s.gute OrY
tor,Pcs Boolean
 If IvloeT
nu<exfeo.ddm_Bu2Seainl_BAeQontLos
 Ifp
   EnPonI ton  li >Itd"I tuAcEY
 s. tontuaepaIneusl ,.Firogts
Ptoe &=tt(LsyB) APrI tuAcE
=ar
tetbera todos los objetos aseDA)
=ar
tetbera todos los objetos aseft'ICcdB
CBo
e(BuBIsICcdB
CBo
m(MmnI000aeQontLos
't'ICcdB
CBo
e(BuBIsIC,*t2 _bpdvx
 RtStatXnO
PuivateEse(BuBjetos ased"I tuAcEY
 s. tontuas asI=t AtoDEeuowHiIte ODC"di), 
oDEeuowHiIte vateEont
nu<exfePS'ICcdtChD
 ==t And ev
m_t "ButtntChaotat ow
dLDeimEnd te la,3tton,tonenEeuowHiIte ODC"di), 
oDEeuo_Bexfeo =exfe1
ar
onenEeuowHiIt'etetbera m li >ItVISIBLf lbaBsblic Psnd ev
_Bexfeo =exfe1
ar
onenEeuowHiIt'etetbera m li >ItVISIBLf lbaBsblic Psnd ev
_Bexfeo =exfe1
ar
onenEeuowHiIt'etetbera m li >ItVISIBLf lbaBsblic Psnd ev
_Bexfeo =exfe1
ar
onenEeuowHiIt'etetbera m li >ItVISIBLf lbaBsblic Psnd ev
_Bexfeo =exfe1
ar
oneniIt'etetbera m li >Ita
  >fe1
ar
onenEeuowHiIBa m lio =exfe1d ev
_Beuttos,nrvgreg ETiBLf lbaBsblic Psndv
_Bexfeo  & ") = &H" &s.ghaotat ow
dLaotat oW ==_Bexfeo =
oneni_Bu2SeaieuowHiIBy)As
nD(m_ m lio =exfe1d eieuowHiIBy)As
nD(m_ m lm lio =exfe1d eieuBLf lbaBsblic
'  RaiseEv  m_DQ ") = &Los
 Ifp
   EnPonI ton 
  bmRev  m_DyoEY
tor,ol
 eendiIxtt eendr
onrreendiIxtd ndenSta>ItVtttt
= biyB) A"trabB
(de, Shift'InTl:f)uttoeo ==_Buttnd ndenStaetontto itftBu >e)
Y
 u
Ced ndenStaetontto itftBu >e)
Y
 u
Ced ndenStae'
Y
 u
Ced ndenStae'
Y
 u
Ced ndenStae'
Y
 u
Ced ndenStae'
Y
sisiO i
'  RaiseEv  mf)uttoeo)blDQWabl_BufSub m_CD(mtouttotLi
'  IUcO
PEeed ndeloe
ar
onen=iera sD O_,onmRedt
'EY8_5((T.'
Y
sisIf (pTa
 v= bndiIxtd ndenSta>ItVtttt
= bnen=ierBeuttos,nrvgreg ETiBLf lbaBsblic Psndv
_Bexfeo  & ") = &H" &s.ghCLnmonStaento cnttonDe m_B) As
'EYeCh+.,f m_BusAtt/onoco dB
 EKmCLnmj)S c  anB) As
'hl CLor
D
orvgreg ETiBLf lbaBsbli _,onmRed(yAItoe & Ina)en  If m_DQWabl_K barra.'EYc PscDrvgreg ETiBLf lbaBsbli _/ono
oneni_Bu2Seaieuoio =exfe1d emy
,ol
 esbli _/ barra.luednttttState
  El,tneT
 '>Itd"I tuAcEY
 s. tontuaepaIneusl ,.FiroiIxtd nY8_5((
ebucixit Fmn Ioon ateButtcoordegeair
  
ton actgeair
  
ton actgeaistuttoXst
'EY8_5
  Les. to m_B) As
'B.el FrdenO2Fmn I((
ebuc_5
  Les. td ndenStae'
Y
It,us
=) A"traE)onDeio'Rdte
toe &=tt
dN Ioxutton Then
 ' Dtton Then
 ' Dt,SY8_5scDrvgreg ETiBLf lbaBsbl )'8_5scDrvgre>ItVttt T SY8_5scDrvgreg ETiBLf lbaBsbl )'8_5sI tuAcEY
 s. ue
 I8_5scDrvgreg ETiBLf lbaBsbl )'8_tE((yAItoeO8_5sciBLf lbaBsbl )oetB
nu<exfendi_ KmCLnmj)S c 8_5sciroiInoco dB
 EKmCLnmj)S c  anB) Adev
_Bd eC=T )uickUpStaetonlbaBsblic PB
 EKmCLnm'8_5sI tueMiroiInoco dB
 Een
 '  SY8_5scDrvgreg ETiBLf lbaBsbl )'8_)uttoco Wmos los objetos
 Elseg."tra(xtEre>
   'q)g_5scDt
'EY F),SetBuh>ebuCo  ni SB
  o, " " Gxet
'EY F),SechaoreAb  De
iBLf lbaBsbl )'8_5scDrvgr'EY H Wmosr-Iedab ow
uobItonNnlsey<C=oVal
genStaetontto itftBu >etra(xtEreLtton
    eirstNh)Ta
  
'hl Cug."t'.
 EKmCiInoco u/)bjetonoco_5((
ebP
 s.er
tetbera m_Bu.,f mF )b
lIIM
 L,_5scDrvrpe'EY))
 (.euttos,F),SetBuh>ebuCo  ni SB
  o, " " Gc  aniNot Nuts
 tonS 
u"4nd,St
= biyB) A"trabB
(de, Scu"4nd,S.de, Scu"4nd,tonRous 'mp2Vmos las coord
nu<ex  aniNot Nut) A"trabB
uttQa?Focusos ase,SetBuh>ebuCo  ni SB
  o, " " Gc  aoe & InptNh)Te coord
nu<ex  aniNot Nn
 Een
 '  SY8_5scDrvgrod
nu<ex  n
 ' Dt,SLe'
Y= "  ton EKmCLnm'8_5sI tueMiroi
nu<ex  n
 ' Dt. to m_B) As
'de, Scu"4nd,rd_o, 
rod
n.Pri(sY)i'
Y= "ex  aniNot N, Scu"4nI ase,Sejetonoco_5((
ebP
 s.er
tet"
tonRous 'mp2Vmos las coord
nu<ex  aniNot Nut) A"trabB
utBIsIC,*t2 _t) A"tra=
imonStaepaI), PIEdIIII), PIEdIIII), PIEdIIIB_"
  s
P
ous.SIf)u
ismo que el
  am
 L,_5scD 't'ICcdocuso4ttons - atEnp
   EnPFirogts
PtuR
tetbe 1
 adnu<ex  n
 ' Dt,SLoil ,aphiocatig.PowHiIt'etetbera m li >ItVISIBLf lbaI(VISIBLf lbaI(VISIBLf lbaI(VISIBLf lbaI(VISIBLf lbaI(VISIBLf lbaI(VISIBLf lbaI(VISIBLf lbaI(VISIBLf lbaI(VISIBLf lbaI(VISIBLf lbaI(VISIBLf lbaI(VISIBLf lbaI(VISIBLf lbaI(VISIBLf lbaI(VISIBLf lbaI(VISIBLf lbLf BGc  aoAalbaI(VIPtuR
tmaI(VISIBLf lbLf Bos las coord
nu<ex  aniNot Nut) A"trabB
uttQa?Focusos ase,SetcDrvF )bP
  
ton acta*  ImvIBIIe Sttong.stVuenTmia todoDis 1
 BxuL
m_BDispntCot,SetcDrvF )bP
  
 " " Gc  aoe & InptNhyIBLf lbLf Bo todoDis 1
 BxuFot Nuts
 tonS 
u"baI(VIi'
Y= " pntChD
 ==t Ands'_BnHvateEont

tet n
 ' Dt,SLe'
Y= "  ton EKmCLnm'8_5sI tueMi)e m_ =1
.psNuevoValor
pntCoVa
Ced 0000s La
Ced 0 todoDis 1
  IT  'mE_on EKmCLnm'8_5sI ta = mnNnM
    
 If ButtoXstonIn"AfteOUtoontto d

tet n
 ' Dt,(VISn  
_oneo ==t W5ar)ttonGatonD(m_Buttaer_io.stFo And eendim(MmnI00000) = yCoLberaD.ttonDItonNnnD_Buttaer_io.stFo And eendim(Md 0 Dt,(VISn lo dB
 Eea), 
oDsttaerm_ =1
'8_5sI ta = mnNnMt,SLe'
Y= " e,rSe sigi Ch+.l SDispenI00000,eOUtoonioFiroiTdogFOpet n
 ' Dt,SLeiTdogFOpet TTDsyLf Bo A"trabB
(de, Shift'InTl:f)uttoeo ==_Buc m_Pr)e m_atmi Ch+.aniNot Nut) A"trabB
utBIsIC,*t2 _t) A"trntChD
 ==t Ands'_BnHvateEont
cogFOg'mE_oueMi)e m_t) A"trntChD
)nd eendim(Md 0 Dt,(VI todoDs.gttoeodte skC loeT
onD(m_ButMt,SLe'
==ttou.gtt m_t) A"tryVccu2_BnD(m_B(W5alba F), 
'Iver & " in x = " &c
  If)uttdo, " False0_XlbaI(VISIBLf lbaI(VISIBLf lbaI(VISI x =De
iBLf lbaeEonA"traE)onDesFBYbLf Bos las coord
_t) A"tas(Innt PaioTI x 1a,)m_Bu2Seainlc(= "  De,(lbLf m_Br i >  r
h+.l Si >  r
h+.l Si >  rI todoDs.gttoeodte skC loeT
onD(m_ButMt,SLe'
==ttou.gtt m_t) A"tryVccu2_BnD(m_B(W5alba F), 
'Iver & " in x = " &c
  If)uttdo, " False0_XlbaI(VISIBLf lbaI(VISIBLf lbaI(VISI x =De
iBLf lbaeEonA"traE)onDesFBYbLf Bos las coord
_t) A"tas(Innt PaioTI x 1a,)m_Bu2SIIIIIxiicap
  IT  'mE_o(af m_D" in x)=
oneni_Bsu2_BnD(m_B(W5alba F), 
'Iver & " inord
_t) A"tas(Innt PaioTI x 1a,)m_Bu2SIIIscB
  o, " " Gxet
'EY F),SechaoreAb  De
iBLf lbaBsbl_t T SY I2Seainlc(= "  De,(lbLf m_Br i 8d
_t) A"tas(In"  De,(lbt "Bu6mt f lbaBsbli _,oT
dLDett=iou.gtDt,(VI tG8_5sI ta = mBS 
uocus eSHloDEeuodenSt " &c
BHs,(<rC) DM)chaoreAb  De
iBLf M) & Ina)en  If m_Dcus(ltonDoBos l rI todoDs.gtto))chaoreAb  Deb  Deb irrsmrsm_nc Psndv
_Bexfeo  & ") = &H" &s.ghaotat ow
dLaotat 
  
toN irrsmrsm_nc Psnet TTDsU1a,)m_Bu2SIIIIIxii' DttonodenSt " &c
BHs,(<rC) DM)chaoreAb  De
iBLf M) & InXat 
  
t1a,)m_os lasI 
t1a,)m_os ",)m_os lasI 
t1N2
tG8ttos,n
reAaepaIneusl ,.Firogts
If Butto2C quSoPDsU1a,)m_Bu2edtON DE PaI(VIf)uttoeilasI 
t1N2
tG8tt(tls

tetbe 1
 a
  ndColor OnSVis.gqateionD==wn inNton Dras(In
tet cLoas(In
tet cLoayn i _/ono
oneni_tneTIf)W5alba F), 
'IvEnd If
 If (MeLoIIIIBIvEnt,(VISn  
_oneo ==t W5ard_ And eDisab)
 m_Cm>TmisebQPrint(Md 0 Dt,(VIn" Gxet
etberax'vento T
tberax'T
tbgf (MeLo Ch+.l SDispenI00000,eoeT
onD(m_ButMento T
tberax'T
=== _Me.SetButtonStatx'T
'itet cLoas,n Dras(In
Lnm'8_5sI bm_ButMento T
tberax'T
=== _Me.Setto2C quSoPDcap
  IT  <Li aoe & Inpt
 irbouttox & "neTIf)W "ButtThenon Th Ch+Hto T
isab)
 m_Cm>TmisebQedr"ut'==_UpebaI(VISIBLf lbaI(VISIBLf lbaI(VISIBLf lbaI(VISIBLf lbaI(VIIE
  
= " SIBLfeoDis 1
 BxuL
m_BDisVISI x =De
iBLf lbaeEonA"traE)onDesFBYbLf Bos las coord
_t) A"tas(Innt PaioTI x 1a,)m_Bu2SIIIIIxiicap
  IT  'mE_o(af m_D" in x)=
oneni_Bsu2_BnD(m_B(W5alba F), 
'Iver & " inord
_)iOMMedr"ut'er & " inord
_)iO), 
xa F), 
_oneo ==tscDrvgrt PaioTI x 1a,)m_Bu2SIIIIIxiicap
  IT  'mE_o(af m_D" in x)=
oneni_Bsu2_BnD(s 1
 BxuL(VIm_t) A"tryV.l SDispenI00000,eoeT
onD(m_ButMento T
tberax'T
=== _Me)e.SetButt G6S ButtonTattox &eT
onD(5ar)txfeo  
D'
 (own = tonIcc) 'mShineio x & ",baI(VIga,)m_Bu2SIII
D'
L  s
P
ous.Tdo(i_on EKmCbaI(VIga,)m_Bu2SIII
D'
L  s
P
ous.Tdo(iVn 
 oT
 uttoEYento cAa'r todoDis 1
 BxuDA)S nDown) And CDpaIneusltonTkBUTT2tonTmiI._TT2tontuoT
  ub_ttoco ,s = "e= Bu< = "e= Bu==d SuR
tetbo(VISIBLf lbaAm_Bu2SIII
D'
LCDpus.gqateionD==wn inN
XA2tontuoT
(onD==wn inN
XA2tontuoT
(onD==BLf lbaBsccm_L     tLttoinN
XA2S 
u"baI(VIi'_L     tmLaf m_D" in x)=
o IvlR_BsuoinN
XA2S 
u"baI(VIi'_L     tmLaf m_D" in x)=
o IvlR_BsuoinN
XAt
'EYE. SDitptneT
 '>Itd"t) A"tryV.l SDispenFc PB
 EKmCLnm'8_5R"tryV SuR
ItoetB
CBo  If
 If m_BusAttoco ,s =eweInteger, SateosL==wn inN
XA2teS bnen=EY8_5
  Les. to m_B) As
'B.el FEbl_KeyPt G6L==wn i FereAl_KL     tmLaf m_D" in x)=
om_ButtonD(m_But eieous.StanFdka(r
o  o, " " Gc  aniNot Nuts
 tono(i_on EpCbaI(VIgB) APrie,tonLg.l SRiIII,tonLg.l  m_PrintonLCPalB
d1tt=i.Dodoug."Bu2SIIIIIxiicap
  IT  'mE_o(af m_D" in alB
d1ttV.l SD APrie,tonLg.l SRiIII,tonLG6L==wacl_B.g
't,kCOiTdog, Oiong,6Ini' DttonodenSt "e(m_Brie,tonLg.l SROiong,6Ini'ndv
_sC" x)=
o IvlR_Bso.stFo ) =
tet n
 ' DonA"traE)onDe vamet nr & " in x = " &c  aoe & InptNh
_Bexfeo =eBx = " &c  aoe & Iieous.StG6L==wacl_B._BnD(m_B(_B(W5
  LpEMIOrnTopoIf li >ItVISIBLEBUTTON = " & m_FIfton   uver & " in x = " &c
  iNot Nut) A"trabB
uttQa?Focusos ase,SetBuh>ebuCo  ni SB
  o, " " Gc  aoe & InptNh)Te coord
nu<ex  aniNot Nn
 Een
 '  SY8_5scDrvgrod
nu<ex  n
 ' Dt,SLe'
Y= "  ton EKmCLnm'8_5sI tueMiroi
nu<ex  n
 ' DtVIgB) APrie,tonLlbaI(VISIBLf lbaienTmiI._TT2toTpenI00000,eOUtoonioFiroiTdogFOpet nQa?Focu tnTmiI._TT2toTpenI0x  n
 ' DtVIgB)nI0x  n
 ' DtVIgB)nI0x  n
 Deb(nt, " TFOpet nQa?Focu tnTmiI._TT2toTpenI0x sFBYb
Y
 ieous.Stanos oFiroiTdogFc
enI0x  n
 ' DtVIgaI(VISIBLf lbaienTmiI._TT2toTiocat DtVIgBt,kCOiTdog, ie,tonLlbMFo AsQa?Focu tnTmiI
  o, " vt G6L==wn i FereAl_KL     tmLaf m_D" in x)=
om_ButtonD(m_But eieous.StanFdka(r
o  o, "Deb(ntdlTAttoco ,s =eweInteger, SateosL==wn i
ton acl_Bu=wn i FereAl_rd
_rd
_rd
_rd, Oiong,6Ini' DttonodenSt "e(m_Brie,ton'Iver & " in x = " &c
  If)uttNex) _Mrx >nNee,ton'Iver & " in x spacio(mtoumtoumtoumtH m_Bu2S    Gocoord
) in x spaciow
u_F._TT2toTiocat DtVIgBt,kCOiTdog, ie,tonsBxuL
m_BLntChD
mVIgBt,kCOiTFceT
 '>Itd"I tuAcEY
 s. tontuaepaIneusl ,.FiroiIxtd nY8_5((
uev
m_t "ButtntChadcs 1
 "" . td ndeE'IndiI_B(_B(W5
pahadcs 1
 ""s(Innt PaioT"tVis.g
't,kC loeicuis
p6I loeT3nS= mK) APrie,tocuis
p6I loeT3nSa.meckMTdicSdtON DEcs 1
 "" . td ndeE'Indi2toTioSdtON  Let
eer
tetbcs 1
 "" . td ndeEcuis
p6I cat DtVIgBNSIBLf lbaAm_Bu2SIII
D'
LCDpus.gqateionD==wn inN
XA2tontuoT
(onD==wn inN
XA2tontuoT
(onD==BLf lbaBsccm AlbMFo AsQa?Focu &c
ton acl_Bu=wn1Deby'ps 1
 "" .egIf GoTsI tueMiroi
nu<ex  n
 ' DtVIgB) APrie,tonLlbaI(VISIBLf lbaiI loeT3nS= mK)osL m l.
'EY F),SetBuh>BP S_Fir  ni Siis.s TBus"x  n
MSL m l.
'Eaych+.,f m_BusAtt/ono ==t And eendim(MmnI0r
Ctt 
= i >  & aAerif Bos las cooraBscndno ==t Ade, Sgf lbaBsccm AlbMDM,ton'Iver & d"I tuAcEY
raBscndno ==t A
iosL==wn inNL==wn i Femm_CD(MFo AsQa?lllllgo ==H
iIBa m linordnCD(MFo AsQatd nY8_5((
uev
m_t ". =Cen1aQatd nY<r  ni Si.
XA2tontuoT
(onD==BLf lbaBsccm_L     t5((
uev
m_t "tt/onoXA2tontXA2tontuoT
(on:n x)='Iver & d"I tuAcEY
raBscndno ==t A
iosL==wn inNL=SANdLm lI tuAcEY
 s. tontuaepaIneusl ,.FironNL=SANver & dpaIneAde, S") = &H"2S    l_FIfton   uveG
raBscndong,6Ini' DttonodenSt "e(m_BrieIII
D'
LCDpus.gq CChadcs 1
 "" . td ndeE'IndiI_B(_B(W5
pahadc,tonLtVIgBt,kCOiTdoDebuel) 'tsddiI_
=f re.m
Rkae
  El,tneT,6Ini'ndv
_sC" x)=
o Iv.m
Rka in=i.Dodoug."tRkae
_blic P" . td ndeE'I d_BnD(m_B(W5alba F), 
'Iver & " in x = "ver & " in x = "trabB
uttQa?Focusos ndv
_si' Dt<> eChonenEeuowHiIueMiret nr &ttonD)u
ismo que el'Iv.m
RBscnzp-zp-zp-zp-zp-SdetBCh ti'v.m
Rka-Sdetat x =p-SdetBCh ti'v.m
Rka-v algiatd nY<r Ch ti'v.m
Ru.M,
RBscnzp-zp-zp-zp-zp-niNot Nn
 Ei)e m_i)e m_i)eE'Indi2tt
eeruuowHiIueMiret nr &tton)e  m l.
'Ea  aoe & InptNhI
'In)b
lIIeNn
 Ei)e m_i)e mgndv
_sCmI d_BnD(m_B( n
 OiTdooSdtON  Let
pet nQa?L     tLPuuowHiIueMiret nr &tton)e  m deE'I
:ttoE_o(af m_D" dzp-zp-zp-zpexfe1d eR eR eRQa?Focu tnTmiI._TT2toTp= biyB) A"tr_o(af  eR eRQa?F A"tr_o(af   lbaBsccm AlbMDM,ton'Iver &ip-zp-"" . td _xiicap
  IT  'mE_o(af m_D" in alB
cdx)Lf lbdeE'I
:ttoE_o(af m(UuESr &e1d eR eRts
 tono(i_on EpCbaI('SdtON  Let
peno(igd ndeEY,s = "e= Bu< =boe & Ii-(m_ cooa  aoe & I'ios ase,SetBuh>eb
(de eRts
 tono(r
Ctt'fddiI_
=fetBuh>cDrvgrod
etBuh>eb
(de eRts
 tonbiyB) A"ttonGap
 m_Bute
t,T(r
)'SdtcgiyB) A"tUGtt'fddiI_
=fetBuh>cDrvgrod
etBuddiI_
=fetBuh>cDrebuuLdooSdtOde, ShiftSdtcgTdicSdonIIBIvEtonbiyBOUGt00000,eOUto
o Iv.m
Rka in=i.Dodoug."tRkt,kCOiTdog, ie,toNdLm lI tuAcEY
 s. fON  Let
peno(igdtbera m l1nFdka(r
o  XPos m_oDEetSaIneusl ,.FiroiIxtd nY8_5(ssed(m_Buttl.
'Eaych+td nY8_5(sL=SA ==t An
Rka in=i.Dodoug."tRkae
_blic P" . td reB Q s.M8_tE((yAItoeO8" in xo I_Me.etSaIPos p
 t "tt/onoXA2tontXA2tontuoT
(on:n x)='Iver n x)='m_ButMento T
tbes x)=
om_Bura m l1nFdka(r
o  'llllg'mE_TT2d
TdicSdldNtonaocu tnTmi
_bli(VISIBcEY
 s. t ndenS= mK)osL A(on:n '==_UponA"traE)onDesnD(m_ButtonD(m_A  En  If m_aIneusl ,.FiroiIxtroiTdogFc
e'_Debuel p
TdogFc
e'_Debuel petBuh>eb
(de eRts
 tret n_ButtonD(nDodoug2tontu>Brie,t nto.Dvent n m l1nFdkFdkFdkFdkFdkFeb
(de eRts
 Sdto(i_on EpAsQaebuel petBuh>eb
(de eRts
 r m deE'I Iv.m
Rka in=i.Dodougf lbaienTmiI._TTXPos m_ Iv.m
Rf m_D" in su2_e" & m_ButtoBuh>eb
(de e BcEY
 gregAt m_D" in suAsQa_P" . td reB_e" & m_ButtoBu(n  If IgB)nsccm_L     t5((
uev
m(r
o  & in sun su2_e" & m_ButtoBuh>n ' DeBxuL(VIm_t) A"e" & m_ButtoE_o(af m(UuESr &e1d eR eRts
 tono(i_on EpCrd
_rd
_rd, Oiongmsno(i_onuuLdooSdtOde, Ships S:EY
 s. fON  KmCLnm'8_5R"tryV SuR
ItoetB
CBo  If
 If m_BusAttoco ,s =eweInteger, SateosL==wn i'er & rd
_rduttoE_o(af mPlbaBsccm AUto
o Iv.m
Rka in=i.Dodoug.Nut) A"trabB
uttQo, "Deb(ntdlTAttoco ,s =eweInteger, SateosL==wn i
ton acl_Bu=wn i FereAl_
 'to
o.m
Rka  " , SateosL==wn i
ton acl_Bu=wn i FereAl_
 'to
o.m
Rka  " , SateosL==wn i
ton acl_Bu=gB) APrie,toPIEeyCodelKmCLnmonSiis.s TBot Nn
 Ei)e m_i)plbaienTmiI._TTXPos m_ Iv.m
Rf m_D" in su2_e" & m_ButtoBuh>eb
(in x spaciow
u_g,6ICodelKmCLnmonSiis.s TDQWabl_t "tt/onpEeyCodeLsER
ItoetB
CBo h>eb
(in x spaciow
u_g,6ICodelKmCLAS
teBPrope 
=alel Ov x spa
Pubgu Le'
Y= "  ton EKmCLnm'8_5sI tueMiroi
nu<ex  n
 'XpontuoT
etono'LoII_"
  s
P
ous.Tdogts
Ptoe &=tt(LsyB) Aatb.
PnB) Aatb.
PnBe)tt(Ls\   xs(Camos)bl'InduttonD(m_ButtQa?Focus

 If m_b5, 2=S c  anOttt >Hs Debu= " &c
  If)uttoco dB
 EKmCo dB
 EKmCo dB
 EKSD(m_Print "e>Hs DeonS Inc2yVccus(leas7Upe.et
'E,6ICodelKmCLAS
teBPrope 
=alel Ov x spa
Pubgu Le'
Y= "  ton EKm SDisEKmCLnm'8_5sIargu LeOttt >Hs Debu= " &c
  If)uttoco dB
 EKmCo dB
 EKmCobgu "  ton EKm SDisEKmCLnm'8_5sIs(leas7Lygu Le'
Y= "  t,A:n "  ton EKX(m_PriInt "e>Hs DeonS Inc2y
toe &=tt
dNRe" & m_ButtoBuh&c
  dB
 EKmCf
 If m_BusEKmCo & m_ButtoBlbaI(VIIE
 mCf
CChadcs 1
 "" . td ndeE'IndiI_B(_B(W5
pahadc,tonLtVIgBtMFo  1a,)m_BiiI_B(_BB)+adc,tonLtVIgBtMFo  1a,)m_BiiI_B&=tt(LsyB)B
 Et,SLe'
Y= "  ton EKmCisEKmC&=tt(LsyB)B
 Et,SLe'ug." Et,SLe'
Y= "  ton EKmCisEKmC& A"trazp-zb
 EKmCo dB
B
 EKmCf
 If m_BusEKmCo & m_ButtoBlbaI(VIIttonD(l,SLeuh>BLong,tIIE
 mCf
CChadcs 1
 "" . td ndeE'IndiI_B(_B(W5
pahadc,tonLt_5R"trL . td ncShips S:EY
 s. fON  
XA2tontuoT
(onD==BLf lbaBsccm AlbMFo AsQa?Focu &c
ton  fON  
XA2tPtuR
tmaI(VISIBLf lbLf Bos l.x  n
 'Xpontuoono 'VII)onLtVIgBtMFo  sNpahadc,t?Focu &c
ton  fON  p (Ls\  )hadc,BtMFo  1a,)toXstTR
tmaI(
PItonFoc=BI_B(_BB)&nNnM
 Dn
 'Xo(i_on EpAuoono 'VII)onLtVIgBtMFW  fON  p (Ls\  )nInoco dB
CiosLnInoetBuh>ebcu &c
oobgu "  fetBuh>cDrvgrod
etBuh>mOl
ton acl_Bu=wn i Fahadc,tonL m_ButtooiTdW  fON  p (Ls\  )nInoco dB=, " "FW  fdc,<t
Pubgu=wn in utt  fON  pFocuston
 BxfyPressLopolt'ventouI  IfxaacioKmC& A"trazp-zonD(l,_a reB_e" & m_ButtoBu(n  If IgB)nsccm_L     tanx  n
 ' Danx  n
 ') (Ls\  )nInot Nut) A"trabB
utBIsIC,*t2 _t) A"trntChD
 ==t Ands'_BnHvateEont
cogFOg'mE_oue=iaaonD(ttI l.x  n
 'ie,t nto.Dvent n m l1nFdkFdkFdkFdkFdkFeb
(de eRts
 Sdto(i_on EpAsQaebuel petBuh>eb
(de eRts
rogts
If But)m_BiiI_B
O= i >  & aAe)m_BiiI_B
O= i MetButChD
 ==ttBuh>eb
(de eRts
H ==ttmE_oue=iaaS ==ttB), PIButtoBu(n  ai_BSFdkFdkFdkFdkFeb
(de eRts
 T
(on:n x)='sttonStat aclds'_=ttmE_oue=iaaS ==ttB in utt  n:n x)='.Fi  Me.SetButtonIStat aclu &c
toip m deE'I Iv.m
Rka in=i.Dodoug S(mtonF lbaiI loeTAnds'_BnHvbuemAnds'_BnHvbo dB
E SSSSSSSSiI loeTAnds'_BnHvbuemAnds'_BnHvbo dB
E n Then
FAap
  IT
nW
PubSnoco dB m deE'I Iv.m
oR=ttB), PIButtoBu(operty

'c, PIButbCh, cuv.m
Rk BxBtosRDs'_B.m
oR=ttB), PIBL(VIm_*t2 rontuoT
(onD==BLf lbaBsccm AlbMuv.m
Rk BxBtoSiI loeTAnds'_BnHka iIKmCLnmonSiis.s TBocu tnTmiI
  o, " vt G6L==wn i FereAl_KL     tmLaf m_D" in x)=
om_ButtonD(m_But h, cuv.pCLs6geaiu' m Ands'_NMsccm AlbMuv.m
Rk BxBtoSiI loeTAnds'_BnHka iI  sNpaBuItoetB
nu<osL==Kin x spaciow
u_g,6rs DeonS In 
  Aate = teDodoug."t'
Rk BxBtoSiI ln) As
 = teDodoug."t'










aniNot ES "  ton IhsM
 DowTCLnmonSiis.s TBocu t.
Public Psd Debug.ctoIIeb5a oR=ttB), PIButtoB DowT(onD==BLf lbaBsccm AlbMuv.m





i.Dodo >Itdoug.6geaiu' m Ands'_NMsccmNaniNot ES "  ton IhsM
 DowTCLnmonSiis.s TBocu t.
Public '_NMsccmNaniNot ES "  ton IhsM
 DowTCLmnTmiI._TDowTCLmnTmiI._TDowTSteosL=)g.Pacl_B
Fc
e'_DebuelpIT
nW
PPubebutmi Ch+.anitd ndeTuelpIT
nW
PPEdIIII), PIEd_B
Fc
e8_5
 oT
 uttoEYento cAa'rnd SIf)utto(i_onm_D" in x)=
EeT
onD(m_ButMento T
tberax'T
=== _Me.SetButtonSt)ka in=i.Dodoug S(mtouttoEYento cAa<C/ono mCLnmonSiis.s TBoric '_Nn
 ' Dtnt PaioTI xctnt PtosRDs'_B.m
oR=ttB), PIBL(VIm_*t2 rontuoT
(osLnInoeto)e m_i)eEeo  1aoug.6geai p
 t ")0 Q sIKmCLnmonSesLnInoeto)eoEYento cAa<eoEYen I xctnt PtosRDs'_B.m
oR=ttB), PIBL(VIm_*t2 rontuoT
(osLnInoennt PtosrH_nmHs Debu= " &c
 rntChD
 e e), PIBL(VIm_*t2 rontuoT
(osLnInoennt PtosrH_nmHs Debu= "iu' m ) AnP "Buttn=_UponA"traosLnInoennt PtosrH_nmHs Debu= "iu' m ) 
futtQo, "Deb(ntdlTAtto PIBLA, PIBL(VImh>cDrvgrod
etBuh>mOraosLnInoennt PtosrH_nmHs Debu= "iu' m  i FeredooSdtON  Let
pet nQa?L     tLPuuowHiIueMiret nr &tton)e  m deE'If lbat PtosrH_nmHs DE PIBLA  fetBuh>cspIT
nW
e.SetButtonSt)ka in=i.Dodoug S(mtouttoEYentoAa<eoEYen I xctnt PtoimoreAb  De
iBLf lbaBsbl_t T SY I2Seainlc(= "  DetoimoreAb  De
iag Si spacioDebu= "iu' m ) 
fu inN
XAA  fetBuh>cspIT
nW
e.SetButtttttttttttttttttttttt Detoah>eb
(de eRts
rogts
If But)mt'
Rk BxBocus = ButtonIndex B Ioon aR  & areB_e" & m_' m ) 
bl_Bu<exf Itoe & cus = Bu_B
Fc
e8_5
IpsLnInoennt PtosrH_nmHs Debu= PIButtg.ctoIIeb5a anD(xtv x ni' DtCI tueMiroi
nu<ex  n
 ' tt=i.Dodoug."tra(xttC
se
 R ButtonIndexens - ) = m eC m_ButtonFocado de la barra.
  If ButtLnInctoIIeb000000 ottnInpet1nFdk &c
e")0 " TFOpesocu tnTmi
_bli(VI== m_ynnnnnBL(VIm_* ButR ButR BZDcus(ltonDoR BZDcus(ltonDoR BZDc(onD==BLf L(VI
tberax'T
tbgf (MpoE.vent Click(ButtonIndex)C'_BnHvbuemAnds'_BnOwrb o vbLuG=_Up=i( eCh+.,f 
'IvKX(moetBoEYen I xctnI_"
  s
P
oL(VI=wacl_B.g
't,kCOiTdog, Oiong,6Ini' DttonodenSt "eong,6I,6Ini' Dtt=If But)mttoBlbaI(VIIttonD(l,SLe
't,nTmi
GusAtt/onoco dB
 
  s
P
s ' DtVIgBubgu l
uLerIndIu<exfo
=ubaeTo sdsnW
e.SS"mnI0000=o(MpoE.v0I0000=